#include "test_bt_objects.h"
#include "test_bt_resources.h"
#include "built_in.h"


// TFT module connections
char TFT_DataPort at LATE;
sbit TFT_RST at LATC1_bit;
sbit TFT_BLED at LATA9_bit;
sbit TFT_RS at LATB15_bit;
sbit TFT_CS at LATF12_bit;
sbit TFT_RD at LATD5_bit;
sbit TFT_WR at LATD4_bit;
char TFT_DataPort_Direction at TRISE;
sbit TFT_RST_Direction at TRISC1_bit;
sbit TFT_BLED_Direction at TRISA9_bit;
sbit TFT_RS_Direction at TRISB15_bit;
sbit TFT_CS_Direction at TRISF12_bit;
sbit TFT_RD_Direction at TRISD5_bit;
sbit TFT_WR_Direction at TRISD4_bit;
// End TFT module connections

// Touch Panel module connections
sbit Drivex_Left at LATB13_bit;
sbit Drivex_Right at LATB11_bit;
sbit Drivey_Up at LATB12_bit;
sbit Drivey_Down at LATB10_bit;
sbit Drivex_Left_Direction at TRISB13_bit;
sbit Drivex_Right_Direction at TRISB11_bit;
sbit Drivey_Up_Direction at TRISB12_bit;
sbit Drivey_Down_Direction at TRISB10_bit;
// End Touch Panel module connections

// Global variables
unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 1000;
char PenDown;
typedef unsigned long TPointer;
TPointer PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton *local_button;
TButton *exec_button;
int button_order;
TCButton *local_cbutton;
TCButton *exec_cbutton;
int cbutton_order;
TButton_Round *local_round_button;
TButton_Round *exec_round_button;
int round_button_order;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TCLabel *local_clabel;
TCLabel *exec_clabel;
int clabel_order;
TBox *local_box;
TBox *exec_box;
int box_order;
TCBox *local_cbox;
TCBox *exec_cbox;
int cbox_order;

void PMPWaitBusy() {
  while(PMMODEbits.BUSY);
}

void Set_Index(unsigned short index) {
  TFT_RS = 0;
  PMDIN = index;
  PMPWaitBusy();
}

void Write_Command( unsigned short cmd ) {
  TFT_RS = 1;
  PMDIN = cmd;
  PMPWaitBusy();
}

void Write_Data(unsigned int _data) {
  TFT_RS = 1;
  PMDIN = _data;
  PMPWaitBusy();
}


void Init_ADC() {
  AD1PCFG = 0xFFFF;
  PCFG12_bit = 0;
  PCFG13_bit = 0;
  // PMP setup
  ADC1_Init();
}
static void InitializeTouchPanel() {
  Init_ADC();
  TFT_Set_Active(Set_Index, Write_Command, Write_Data);
  TFT_Init(320, 240);

  TP_TFT_Init(320, 240, 13, 12);                                  // Initialize touch panel
  TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);                              // Set touch panel ADC threshold

  PenDown = 0;
  PressedObject = 0;
  PressedObjectType = -1;
}


/////////////////////////
  TScreen*  CurrentScreen;

  TScreen                HomeScreen;
  TCLabel          Title1 = 
         {
         &HomeScreen           , //   Title1.OwnerScreen
         0                     , //   Title1.Order          
         109                   , //   Title1.Left           
         6                     , //   Title1.Top             
         99                    , //   Title1.Width         
         15                    , //   Title1.Height       
         &Title1_Caption       , //   Title1.Caption        
         &Tahoma11x13_Regular  , //   Title1.FontName       
         0x0000                , //   Title1.Font_Color     
         1                     , //   Title1.Visible        
         1                     , //   Title1.Active        
         0                     , //   Title1.OnUpPtr
         0                     , //   Title1.OnDownPtr
         0                     , //   Title1.OnClickPtr
         0                       //   Title1.OnPressPtr
         };
const char Title1_Caption[19] = "Test Parani ESD110";

  TLine                  Line1;
  TButton               Info_Button;
char Info_Button_Caption[10] = "Get infos";

  TButton               ButtonSearch;
char ButtonSearch_Caption[19] = "Search for devices";

  TButton               Button6;
char Button6_Caption[13] = "Set PIN Code";

  TButton                * const code Screen1_Buttons[3]=
         {
         &Info_Button,         
         &ButtonSearch,        
         &Button6              
         };
  TCLabel                 * const code Screen1_CLabels[1]=
         {
         &Title1               
         };
  TLine                  * const code Screen1_Lines[1]=
         {
         &Line1                
         };


  TScreen                InfoScreen;
  TCLabel          Title2 = 
         {
         &InfoScreen           , //   Title2.OwnerScreen
         0                     , //   Title2.Order          
         126                   , //   Title2.Left           
         6                     , //   Title2.Top             
         69                    , //   Title2.Width         
         15                    , //   Title2.Height       
         &Title2_Caption       , //   Title2.Caption        
         &Tahoma11x13_Regular  , //   Title2.FontName       
         0x0000                , //   Title2.Font_Color     
         1                     , //   Title2.Visible        
         1                     , //   Title2.Active        
         0                     , //   Title2.OnUpPtr
         0                     , //   Title2.OnDownPtr
         0                     , //   Title2.OnClickPtr
         0                       //   Title2.OnPressPtr
         };
const char Title2_Caption[13] = "About Module";

  TLine                  Line2;
  TLabel                 BtAdresseLbl;
char BtAdresseLbl_Caption[41] = "Text";

  TLabel                 DevNameLbl;
char DevNameLbl_Caption[41] = "Text";

  TLabel                 ModeLbl;
char ModeLbl_Caption[41] = "Text";

  TLabel                 StatusLbl;
char StatusLbl_Caption[41] = "Text";

  TLabel                 AuthLbl;
char AuthLbl_Caption[41] = "Text";

  TLabel                 EncrLbl;
char EncrLbl_Caption[41] = "Text";

  TLabel                 FlowLbl;
char FlowLbl_Caption[41] = "Text";

  TCLabel          Label1 = 
         {
         &InfoScreen           , //   Label1.OwnerScreen
         9                     , //   Label1.Order          
         29                    , //   Label1.Left           
         33                    , //   Label1.Top             
         57                    , //   Label1.Width         
         15                    , //   Label1.Height       
         &Label1_Caption       , //   Label1.Caption        
         &Tahoma11x13_Regular  , //   Label1.FontName       
         0x0000                , //   Label1.Font_Color     
         1                     , //   Label1.Visible        
         1                     , //   Label1.Active        
         0                     , //   Label1.OnUpPtr
         0                     , //   Label1.OnDownPtr
         0                     , //   Label1.OnClickPtr
         0                       //   Label1.OnPressPtr
         };
const char Label1_Caption[41] = "Bt Adresse:";

  TCLabel          Label2 = 
         {
         &InfoScreen           , //   Label2.OwnerScreen
         10                    , //   Label2.Order          
         39                    , //   Label2.Left           
         48                    , //   Label2.Top             
         47                    , //   Label2.Width         
         15                    , //   Label2.Height       
         &Label2_Caption       , //   Label2.Caption        
         &Tahoma11x13_Regular  , //   Label2.FontName       
         0x0000                , //   Label2.Font_Color     
         1                     , //   Label2.Visible        
         1                     , //   Label2.Active        
         0                     , //   Label2.OnUpPtr
         0                     , //   Label2.OnDownPtr
         0                     , //   Label2.OnClickPtr
         0                       //   Label2.OnPressPtr
         };
const char Label2_Caption[41] = "Bt Name:";

  TCLabel          Label3 = 
         {
         &InfoScreen           , //   Label3.OwnerScreen
         11                    , //   Label3.Order          
         55                    , //   Label3.Left           
         62                    , //   Label3.Top             
         31                    , //   Label3.Width         
         15                    , //   Label3.Height       
         &Label3_Caption       , //   Label3.Caption        
         &Tahoma11x13_Regular  , //   Label3.FontName       
         0x0000                , //   Label3.Font_Color     
         1                     , //   Label3.Visible        
         1                     , //   Label3.Active        
         0                     , //   Label3.OnUpPtr
         0                     , //   Label3.OnDownPtr
         0                     , //   Label3.OnClickPtr
         0                       //   Label3.OnPressPtr
         };
const char Label3_Caption[41] = "Mode:";

  TCLabel          Label4 = 
         {
         &InfoScreen           , //   Label4.OwnerScreen
         12                    , //   Label4.Order          
         51                    , //   Label4.Left           
         77                    , //   Label4.Top             
         35                    , //   Label4.Width         
         15                    , //   Label4.Height       
         &Label4_Caption       , //   Label4.Caption        
         &Tahoma11x13_Regular  , //   Label4.FontName       
         0x0000                , //   Label4.Font_Color     
         1                     , //   Label4.Visible        
         1                     , //   Label4.Active        
         0                     , //   Label4.OnUpPtr
         0                     , //   Label4.OnDownPtr
         0                     , //   Label4.OnClickPtr
         0                       //   Label4.OnPressPtr
         };
const char Label4_Caption[41] = "Status:";

  TCLabel          Label5 = 
         {
         &InfoScreen           , //   Label5.OwnerScreen
         13                    , //   Label5.Order          
         10                    , //   Label5.Left           
         92                    , //   Label5.Top             
         76                    , //   Label5.Width         
         15                    , //   Label5.Height       
         &Label5_Caption       , //   Label5.Caption        
         &Tahoma11x13_Regular  , //   Label5.FontName       
         0x0000                , //   Label5.Font_Color     
         1                     , //   Label5.Visible        
         1                     , //   Label5.Active        
         0                     , //   Label5.OnUpPtr
         0                     , //   Label5.OnDownPtr
         0                     , //   Label5.OnClickPtr
         0                       //   Label5.OnPressPtr
         };
const char Label5_Caption[41] = "Authentication:";

  TCLabel          Label6 = 
         {
         &InfoScreen           , //   Label6.OwnerScreen
         14                    , //   Label6.Order          
         29                    , //   Label6.Left           
         106                   , //   Label6.Top             
         57                    , //   Label6.Width         
         15                    , //   Label6.Height       
         &Label6_Caption       , //   Label6.Caption        
         &Tahoma11x13_Regular  , //   Label6.FontName       
         0x0000                , //   Label6.Font_Color     
         1                     , //   Label6.Visible        
         1                     , //   Label6.Active        
         0                     , //   Label6.OnUpPtr
         0                     , //   Label6.OnDownPtr
         0                     , //   Label6.OnClickPtr
         0                       //   Label6.OnPressPtr
         };
const char Label6_Caption[41] = "Encryption:";

  TCLabel          Label7 = 
         {
         &InfoScreen           , //   Label7.OwnerScreen
         15                    , //   Label7.Order          
         19                    , //   Label7.Left           
         121                   , //   Label7.Top             
         66                    , //   Label7.Width         
         15                    , //   Label7.Height       
         &Label7_Caption       , //   Label7.Caption        
         &Tahoma11x13_Regular  , //   Label7.FontName       
         0x0000                , //   Label7.Font_Color     
         1                     , //   Label7.Visible        
         1                     , //   Label7.Active        
         0                     , //   Label7.OnUpPtr
         0                     , //   Label7.OnDownPtr
         0                     , //   Label7.OnClickPtr
         0                       //   Label7.OnPressPtr
         };
const char Label7_Caption[41] = "Flow Control:";

  TButton               BackButton;
char BackButton_Caption[8] = "<- Back";

  TButton                * const code Screen2_Buttons[1]=
         {
         &BackButton           
         };
  TLabel                 * const code Screen2_Labels[7]=
         {
         &BtAdresseLbl,        
         &DevNameLbl,          
         &ModeLbl,             
         &StatusLbl,           
         &AuthLbl,             
         &EncrLbl,             
         &FlowLbl              
         };
  TCLabel                 * const code Screen2_CLabels[8]=
         {
         &Title2,              
         &Label1,              
         &Label2,              
         &Label3,              
         &Label4,              
         &Label5,              
         &Label6,              
         &Label7               
         };
  TLine                  * const code Screen2_Lines[1]=
         {
         &Line2                
         };


  TScreen                InqScreen;
  TCBox                Box1 = 
         {
         &InqScreen            , //   Box1.OwnerScreen
         0                     , //   Box1.Order           
         0                     , //   Box1.Left           
         0                     , //   Box1.Top             
         320                   , //   Box1.Width           
         20                    , //   Box1.Height          
         0                     , //   Box1.Pen_Width       
         0x0000                , //   Box1.Pen_Color       
         1                     , //   Box1.Visible         
         0                     , //   Box1.Active          
         1                     , //   Box1.Transparent     
         0                     , //   Box1.Gradient        
         0                     , //   Box1.Gradient_Orientation    
         0xFFFF                , //   Box1.Gradient_Start_Color    
         0xC618                , //   Box1.Gradient_End_Color      
         0xFFFF                , //   Box1.Color           
         1                     , //   Box1.PressColEnabled 
         0x8410                , //   Box1.Press_Color     
         0                     , //   Box1.OnUpPtr
         0                     , //   Box1.OnDownPtr
         0                     , //   Box1.OnClickPtr
         0                       //   Box1.OnPressPtr
         };
  TLabel                 InqTitle;
char InqTitle_Caption[41] = "Searching ...";

  TLine                  Line3;
  TCButton                Button2 = 
         {
         &InqScreen            , //   Button2.OwnerScreen
         3                     , //   Button2.Order           
         5                     , //   Button2.Left            
         205                   , //   Button2.Top              
         150                   , //   Button2.Width            
         30                    , //   Button2.Height        
         1                     , //   Button2.Pen_Width          
         0x0000                , //   Button2.Pen_Color       
         1                     , //   Button2.Visible         
         1                     , //   Button2.Active           
         1                     , //   Button2.Transparent     
         &Button2_Caption      , //   Button2.Caption        
         _taCenter             , //   Button2.TextAlign        
         &Tahoma11x13_Regular  , //   Button2.FontName        
         0x0000                , //
         1                     , //   Button2.Gradient        
         0                     , //   Button2.Gradient_Orientation    
         0xFFFF                , //   Button2.Gradient_Start_Color    
         0xC618                , //  Button2.Gradient_Start_Color    
         0xC618                , //   Button2.Color           
         1                     , //   Button2.PressColEnabled 
         0xC618                , //   Button2.Press_Color     
         0                     , //   Button2.OnUpPtr
         0                     , //   Button2.OnDownPtr
         BackButtonOnClick     , //   Button2.OnClickPtr
         0                       //   Button2.OnPressPtr
         };
const char Button2_Caption[8] = "<- Back";

  TCButton                Button3 = 
         {
         &InqScreen            , //   Button3.OwnerScreen
         4                     , //   Button3.Order           
         165                   , //   Button3.Left            
         205                   , //   Button3.Top              
         150                   , //   Button3.Width            
         30                    , //   Button3.Height        
         1                     , //   Button3.Pen_Width          
         0x0000                , //   Button3.Pen_Color       
         1                     , //   Button3.Visible         
         1                     , //   Button3.Active           
         1                     , //   Button3.Transparent     
         &Button3_Caption      , //   Button3.Caption        
         _taCenter             , //   Button3.TextAlign        
         &Tahoma11x13_Regular  , //   Button3.FontName        
         0x0000                , //
         1                     , //   Button3.Gradient        
         0                     , //   Button3.Gradient_Orientation    
         0xFFFF                , //   Button3.Gradient_Start_Color    
         0xC618                , //  Button3.Gradient_Start_Color    
         0xC618                , //   Button3.Color           
         1                     , //   Button3.PressColEnabled 
         0xC618                , //   Button3.Press_Color     
         0                     , //   Button3.OnUpPtr
         0                     , //   Button3.OnDownPtr
         Button3OnClick        , //   Button3.OnClickPtr
         0                       //   Button3.OnPressPtr
         };
const char Button3_Caption[8] = "Refresh";

  TButton               dev1;
char dev1_Caption[51] = "";

  TButton               dev2;
char dev2_Caption[51] = "";

  TButton               dev3;
char dev3_Caption[51] = "";

  TButton               dev4;
char dev4_Caption[51] = "";

  TButton               dev5;
char dev5_Caption[51] = "";

  TButton               dev6;
char dev6_Caption[51] = "";

  TButton               dev7;
char dev7_Caption[51] = "";

  TButton               dev8;
char dev8_Caption[51] = "";

  TButton               dev9;
char dev9_Caption[51] = "";

  TButton               dev10;
char dev10_Caption[51] = "";

  TButton               dev11;
char dev11_Caption[51] = "";

  TButton               dev12;
char dev12_Caption[51] = "";

  TButton               dev13;
char dev13_Caption[51] = "";

  TButton               dev14;
char dev14_Caption[51] = "";

  TButton               dev15;
char dev15_Caption[51] = "";

  TButton                * const code Screen3_Buttons[15]=
         {
         &dev1,                
         &dev2,                
         &dev3,                
         &dev4,                
         &dev5,                
         &dev6,                
         &dev7,                
         &dev8,                
         &dev9,                
         &dev10,               
         &dev11,               
         &dev12,               
         &dev13,               
         &dev14,               
         &dev15                
         };
  TCButton                * const code Screen3_CButtons[2]=
         {
         &Button2,             
         &Button3              
         };
  TLabel                 * const code Screen3_Labels[1]=
         {
         &InqTitle             
         };
  TCBox                   * const code Screen3_CBoxes[1]=
         {
         &Box1                 
         };
  TLine                  * const code Screen3_Lines[1]=
         {
         &Line3                
         };


  TScreen                ConErrorScreen;
  TLabel                 Label8;
char Label8_Caption[19] = "Connection error !";

  TButton_Round          OkButton;
char OkButton_Caption[3] = "Ok";

  TLabel                 Label10;
char Label10_Caption[51] = "Text";

  TButton_Round          * const code Screen4_Buttons_Round[1]=
         {
         &OkButton             
         };
  TLabel                 * const code Screen4_Labels[2]=
         {
         &Label8,              
         &Label10              
         };


  TScreen                ConSuccessScreen;
  TLabel                 SuccessLabel;
char SuccessLabel_Caption[21] = "CONNECT 112233445566";

  TLabel                 * const code Screen5_Labels[1]=
         {
         &SuccessLabel         
         };


  TScreen                DiscoScreen;
  TCLabel          Label9 = 
         {
         &DiscoScreen          , //   Label9.OwnerScreen
         0                     , //   Label9.Order          
         40                    , //   Label9.Left           
         73                    , //   Label9.Top             
         239                   , //   Label9.Width         
         28                    , //   Label9.Height       
         &Label9_Caption       , //   Label9.Caption        
         &Tahoma21x25_Regular  , //   Label9.FontName       
         0xFFFF                , //   Label9.Font_Color     
         1                     , //   Label9.Visible        
         1                     , //   Label9.Active        
         0                     , //   Label9.OnUpPtr
         0                     , //   Label9.OnDownPtr
         0                     , //   Label9.OnClickPtr
         0                       //   Label9.OnPressPtr
         };
const char Label9_Caption[25] = "Disconnect from device \?";

  TButton_Round          ButtonRound1;
char ButtonRound1_Caption[3] = "No";

  TButton_Round          DiscoButton;
char DiscoButton_Caption[4] = "Yes";

  TButton_Round          * const code Screen6_Buttons_Round[2]=
         {
         &ButtonRound1,        
         &DiscoButton          
         };
  TCLabel                 * const code Screen6_CLabels[1]=
         {
         &Label9               
         };


  TScreen                PinCode;
  TLine                  Line4;
  TCLabel          Label11 = 
         {
         &PinCode              , //   Label11.OwnerScreen
         1                     , //   Label11.Order          
         118                   , //   Label11.Left           
         6                     , //   Label11.Top             
         85                    , //   Label11.Width         
         15                    , //   Label11.Height       
         &Label11_Caption      , //   Label11.Caption        
         &Tahoma11x13_Regular  , //   Label11.FontName       
         0x0000                , //   Label11.Font_Color     
         1                     , //   Label11.Visible        
         1                     , //   Label11.Active        
         0                     , //   Label11.OnUpPtr
         0                     , //   Label11.OnDownPtr
         0                     , //   Label11.OnClickPtr
         0                       //   Label11.OnPressPtr
         };
const char Label11_Caption[17] = "Enter a PIN code";

  TBox                   cache_pin_str;
  TLabel                 TextField;
char TextField_Caption[50] = "";

  TButton_Round          key_a;
char key_a_Caption[2] = "a";

  TButton_Round          key_z;
char key_z_Caption[2] = "z";

  TButton_Round          key_e;
char key_e_Caption[2] = "e";

  TButton_Round          key_r;
char key_r_Caption[2] = "r";

  TButton_Round          key_t;
char key_t_Caption[2] = "t";

  TButton_Round          key_y;
char key_y_Caption[2] = "y";

  TButton_Round          key_u;
char key_u_Caption[2] = "u";

  TButton_Round          key_i;
char key_i_Caption[2] = "i";

  TButton_Round          key_o;
char key_o_Caption[2] = "o";

  TButton_Round          key_p;
char key_p_Caption[2] = "p";

  TButton_Round          key_q;
char key_q_Caption[2] = "q";

  TButton_Round          key_s;
char key_s_Caption[2] = "s";

  TButton_Round          key_d;
char key_d_Caption[2] = "d";

  TButton_Round          key_f;
char key_f_Caption[2] = "f";

  TButton_Round          key_g;
char key_g_Caption[2] = "g";

  TButton_Round          key_h;
char key_h_Caption[2] = "h";

  TButton_Round          key_j;
char key_j_Caption[2] = "j";

  TButton_Round          key_k;
char key_k_Caption[2] = "k";

  TButton_Round          key_l;
char key_l_Caption[2] = "l";

  TButton_Round          key_m;
char key_m_Caption[2] = "m";

  TButton_Round          key_1;
char key_1_Caption[2] = "1";

  TButton_Round          key_2;
char key_2_Caption[2] = "2";

  TButton_Round          key_3;
char key_3_Caption[2] = "3";

  TButton_Round          key_4;
char key_4_Caption[2] = "4";

  TButton_Round          key_5;
char key_5_Caption[2] = "5";

  TButton_Round          key_6;
char key_6_Caption[2] = "6";

  TButton_Round          key_7;
char key_7_Caption[2] = "7";

  TButton_Round          key_8;
char key_8_Caption[2] = "8";

  TButton_Round          key_9;
char key_9_Caption[2] = "9";

  TButton_Round          key_0;
char key_0_Caption[2] = "0";

  TButton_Round          key_w;
char key_w_Caption[2] = "w";

  TButton_Round          key_x;
char key_x_Caption[2] = "x";

  TButton_Round          key_c;
char key_c_Caption[2] = "c";

  TButton_Round          key_v;
char key_v_Caption[2] = "v";

  TButton_Round          key_b;
char key_b_Caption[2] = "b";

  TButton_Round          key_n;
char key_n_Caption[2] = "n";

  TButton_Round          key_shift;
char key_shift_Caption[6] = "Shift";

  TButton_Round          key_back;
char key_back_Caption[3] = "<-";

  TCButton                Button4 = 
         {
         &PinCode              , //   Button4.OwnerScreen
         42                    , //   Button4.Order           
         5                     , //   Button4.Left            
         205                   , //   Button4.Top              
         150                   , //   Button4.Width            
         30                    , //   Button4.Height        
         1                     , //   Button4.Pen_Width          
         0x0000                , //   Button4.Pen_Color       
         1                     , //   Button4.Visible         
         1                     , //   Button4.Active           
         1                     , //   Button4.Transparent     
         &Button4_Caption      , //   Button4.Caption        
         _taCenter             , //   Button4.TextAlign        
         &Tahoma11x13_Regular  , //   Button4.FontName        
         0x0000                , //
         1                     , //   Button4.Gradient        
         0                     , //   Button4.Gradient_Orientation    
         0xFFFF                , //   Button4.Gradient_Start_Color    
         0xC618                , //  Button4.Gradient_Start_Color    
         0xC618                , //   Button4.Color           
         1                     , //   Button4.PressColEnabled 
         0xC618                , //   Button4.Press_Color     
         0                     , //   Button4.OnUpPtr
         0                     , //   Button4.OnDownPtr
         BackButtonOnClick     , //   Button4.OnClickPtr
         0                       //   Button4.OnPressPtr
         };
const char Button4_Caption[7] = "Cancel";

  TCButton                Button5 = 
         {
         &PinCode              , //   Button5.OwnerScreen
         43                    , //   Button5.Order           
         165                   , //   Button5.Left            
         205                   , //   Button5.Top              
         150                   , //   Button5.Width            
         30                    , //   Button5.Height        
         1                     , //   Button5.Pen_Width          
         0x0000                , //   Button5.Pen_Color       
         1                     , //   Button5.Visible         
         1                     , //   Button5.Active           
         1                     , //   Button5.Transparent     
         &Button5_Caption      , //   Button5.Caption        
         _taCenter             , //   Button5.TextAlign        
         &Tahoma11x13_Regular  , //   Button5.FontName        
         0x0000                , //
         1                     , //   Button5.Gradient        
         0                     , //   Button5.Gradient_Orientation    
         0xFFFF                , //   Button5.Gradient_Start_Color    
         0xC618                , //  Button5.Gradient_Start_Color    
         0xC618                , //   Button5.Color           
         1                     , //   Button5.PressColEnabled 
         0xC618                , //   Button5.Press_Color     
         0                     , //   Button5.OnUpPtr
         0                     , //   Button5.OnDownPtr
         Button1OnClick        , //   Button5.OnClickPtr
         0                       //   Button5.OnPressPtr
         };
const char Button5_Caption[3] = "Ok";

  TCButton                * const code Screen7_CButtons[2]=
         {
         &Button4,             
         &Button5              
         };
  TButton_Round          * const code Screen7_Buttons_Round[38]=
         {
         &key_a,               
         &key_z,               
         &key_e,               
         &key_r,               
         &key_t,               
         &key_y,               
         &key_u,               
         &key_i,               
         &key_o,               
         &key_p,               
         &key_q,               
         &key_s,               
         &key_d,               
         &key_f,               
         &key_g,               
         &key_h,               
         &key_j,               
         &key_k,               
         &key_l,               
         &key_m,               
         &key_1,               
         &key_2,               
         &key_3,               
         &key_4,               
         &key_5,               
         &key_6,               
         &key_7,               
         &key_8,               
         &key_9,               
         &key_0,               
         &key_w,               
         &key_x,               
         &key_c,               
         &key_v,               
         &key_b,               
         &key_n,               
         &key_shift,           
         &key_back             
         };
  TLabel                 * const code Screen7_Labels[1]=
         {
         &TextField            
         };
  TCLabel                 * const code Screen7_CLabels[1]=
         {
         &Label11              
         };
  TBox                   * const code Screen7_Boxes[1]=
         {
         &cache_pin_str        
         };
  TLine                  * const code Screen7_Lines[1]=
         {
         &Line4                
         };




static void InitializeObjects() {
  HomeScreen.Color                     = 0xFFFF;
  HomeScreen.Width                     = 320;
  HomeScreen.Height                    = 240;
  HomeScreen.ButtonsCount              = 3;
  HomeScreen.Buttons                   = Screen1_Buttons;
  HomeScreen.CButtonsCount             = 0;
  HomeScreen.Buttons_RoundCount        = 0;
  HomeScreen.LabelsCount               = 0;
  HomeScreen.CLabelsCount              = 1;
  HomeScreen.CLabels                   = Screen1_CLabels;
  HomeScreen.BoxesCount                = 0;
  HomeScreen.CBoxesCount               = 0;
  HomeScreen.LinesCount                = 1;
  HomeScreen.Lines                     = Screen1_Lines;
  HomeScreen.ObjectsCount              = 5;

  InfoScreen.Color                     = 0xFFFF;
  InfoScreen.Width                     = 320;
  InfoScreen.Height                    = 240;
  InfoScreen.ButtonsCount              = 1;
  InfoScreen.Buttons                   = Screen2_Buttons;
  InfoScreen.CButtonsCount             = 0;
  InfoScreen.Buttons_RoundCount        = 0;
  InfoScreen.LabelsCount               = 7;
  InfoScreen.Labels                    = Screen2_Labels;
  InfoScreen.CLabelsCount              = 8;
  InfoScreen.CLabels                   = Screen2_CLabels;
  InfoScreen.BoxesCount                = 0;
  InfoScreen.CBoxesCount               = 0;
  InfoScreen.LinesCount                = 1;
  InfoScreen.Lines                     = Screen2_Lines;
  InfoScreen.ObjectsCount              = 17;

  InqScreen.Color                     = 0xFFFF;
  InqScreen.Width                     = 320;
  InqScreen.Height                    = 240;
  InqScreen.ButtonsCount              = 15;
  InqScreen.Buttons                   = Screen3_Buttons;
  InqScreen.CButtonsCount             = 2;
  InqScreen.CButtons                  = Screen3_CButtons;
  InqScreen.Buttons_RoundCount        = 0;
  InqScreen.LabelsCount               = 1;
  InqScreen.Labels                    = Screen3_Labels;
  InqScreen.CLabelsCount              = 0;
  InqScreen.BoxesCount                = 0;
  InqScreen.CBoxesCount               = 1;
  InqScreen.CBoxes                    = Screen3_CBoxes;
  InqScreen.LinesCount                = 1;
  InqScreen.Lines                     = Screen3_Lines;
  InqScreen.ObjectsCount              = 20;

  ConErrorScreen.Color                     = 0xF800;
  ConErrorScreen.Width                     = 320;
  ConErrorScreen.Height                    = 240;
  ConErrorScreen.ButtonsCount              = 0;
  ConErrorScreen.CButtonsCount             = 0;
  ConErrorScreen.Buttons_RoundCount        = 1;
  ConErrorScreen.Buttons_Round             = Screen4_Buttons_Round;
  ConErrorScreen.LabelsCount               = 2;
  ConErrorScreen.Labels                    = Screen4_Labels;
  ConErrorScreen.CLabelsCount              = 0;
  ConErrorScreen.BoxesCount                = 0;
  ConErrorScreen.CBoxesCount               = 0;
  ConErrorScreen.LinesCount                = 0;
  ConErrorScreen.ObjectsCount              = 3;

  ConSuccessScreen.Color                     = 0x0400;
  ConSuccessScreen.Width                     = 320;
  ConSuccessScreen.Height                    = 240;
  ConSuccessScreen.ButtonsCount              = 0;
  ConSuccessScreen.CButtonsCount             = 0;
  ConSuccessScreen.Buttons_RoundCount        = 0;
  ConSuccessScreen.LabelsCount               = 1;
  ConSuccessScreen.Labels                    = Screen5_Labels;
  ConSuccessScreen.CLabelsCount              = 0;
  ConSuccessScreen.BoxesCount                = 0;
  ConSuccessScreen.CBoxesCount               = 0;
  ConSuccessScreen.LinesCount                = 0;
  ConSuccessScreen.ObjectsCount              = 1;

  DiscoScreen.Color                     = 0xFC00;
  DiscoScreen.Width                     = 320;
  DiscoScreen.Height                    = 240;
  DiscoScreen.ButtonsCount              = 0;
  DiscoScreen.CButtonsCount             = 0;
  DiscoScreen.Buttons_RoundCount        = 2;
  DiscoScreen.Buttons_Round             = Screen6_Buttons_Round;
  DiscoScreen.LabelsCount               = 0;
  DiscoScreen.CLabelsCount              = 1;
  DiscoScreen.CLabels                   = Screen6_CLabels;
  DiscoScreen.BoxesCount                = 0;
  DiscoScreen.CBoxesCount               = 0;
  DiscoScreen.LinesCount                = 0;
  DiscoScreen.ObjectsCount              = 3;

  PinCode.Color                     = 0xFFFF;
  PinCode.Width                     = 320;
  PinCode.Height                    = 240;
  PinCode.ButtonsCount              = 0;
  PinCode.CButtonsCount             = 2;
  PinCode.CButtons                  = Screen7_CButtons;
  PinCode.Buttons_RoundCount        = 38;
  PinCode.Buttons_Round             = Screen7_Buttons_Round;
  PinCode.LabelsCount               = 1;
  PinCode.Labels                    = Screen7_Labels;
  PinCode.CLabelsCount              = 1;
  PinCode.CLabels                   = Screen7_CLabels;
  PinCode.BoxesCount                = 1;
  PinCode.Boxes                     = Screen7_Boxes;
  PinCode.CBoxesCount               = 0;
  PinCode.LinesCount                = 1;
  PinCode.Lines                     = Screen7_Lines;
  PinCode.ObjectsCount              = 44;


  Line1.OwnerScreen     = &HomeScreen;
  Line1.Order           = 1;
  Line1.First_Point_X   = 0;
  Line1.First_Point_Y   = 20;
  Line1.Second_Point_X  = 320;
  Line1.Second_Point_Y  = 20;
  Line1.Visible         = 1;
  Line1.Pen_Width       = 1;
  Line1.Color           = 0x0000;

  Info_Button.OwnerScreen     = &HomeScreen;
  Info_Button.Order           = 2;
  Info_Button.Left            = 6;
  Info_Button.Top             = 25;
  Info_Button.Width           = 309;
  Info_Button.Height          = 30;
  Info_Button.Pen_Width       = 1;
  Info_Button.Pen_Color       = 0x0000;
  Info_Button.Visible         = 1;
  Info_Button.Active          = 1;
  Info_Button.Transparent     = 1;
  Info_Button.Caption         = Info_Button_Caption;
  Info_Button.TextAlign       = _taCenter;
  Info_Button.FontName        = Tahoma11x13_Regular;
  Info_Button.PressColEnabled = 1;
  Info_Button.Font_Color      = 0x0000;
  Info_Button.Gradient        = 1;
  Info_Button.Gradient_Orientation    = 0;
  Info_Button.Gradient_Start_Color    = 0xFFFF;
  Info_Button.Gradient_End_Color      = 0xC618;
  Info_Button.Color           = 0xC618;
  Info_Button.Press_Color     = 0xC618;
  Info_Button.OnUpPtr         = 0;
  Info_Button.OnDownPtr       = 0;
  Info_Button.OnClickPtr      = Info_ButtonOnClick;
  Info_Button.OnPressPtr      = 0;

  ButtonSearch.OwnerScreen     = &HomeScreen;
  ButtonSearch.Order           = 3;
  ButtonSearch.Left            = 6;
  ButtonSearch.Top             = 60;
  ButtonSearch.Width           = 309;
  ButtonSearch.Height          = 30;
  ButtonSearch.Pen_Width       = 1;
  ButtonSearch.Pen_Color       = 0x0000;
  ButtonSearch.Visible         = 1;
  ButtonSearch.Active          = 1;
  ButtonSearch.Transparent     = 1;
  ButtonSearch.Caption         = ButtonSearch_Caption;
  ButtonSearch.TextAlign       = _taCenter;
  ButtonSearch.FontName        = Tahoma11x13_Regular;
  ButtonSearch.PressColEnabled = 1;
  ButtonSearch.Font_Color      = 0x0000;
  ButtonSearch.Gradient        = 1;
  ButtonSearch.Gradient_Orientation    = 0;
  ButtonSearch.Gradient_Start_Color    = 0xFFFF;
  ButtonSearch.Gradient_End_Color      = 0xC618;
  ButtonSearch.Color           = 0xC618;
  ButtonSearch.Press_Color     = 0xC618;
  ButtonSearch.OnUpPtr         = 0;
  ButtonSearch.OnDownPtr       = 0;
  ButtonSearch.OnClickPtr      = ButtonSearchOnClick;
  ButtonSearch.OnPressPtr      = 0;

  Button6.OwnerScreen     = &HomeScreen;
  Button6.Order           = 4;
  Button6.Left            = 6;
  Button6.Top             = 95;
  Button6.Width           = 309;
  Button6.Height          = 30;
  Button6.Pen_Width       = 1;
  Button6.Pen_Color       = 0x0000;
  Button6.Visible         = 1;
  Button6.Active          = 1;
  Button6.Transparent     = 1;
  Button6.Caption         = Button6_Caption;
  Button6.TextAlign       = _taCenter;
  Button6.FontName        = Tahoma11x13_Regular;
  Button6.PressColEnabled = 1;
  Button6.Font_Color      = 0x0000;
  Button6.Gradient        = 1;
  Button6.Gradient_Orientation    = 0;
  Button6.Gradient_Start_Color    = 0xFFFF;
  Button6.Gradient_End_Color      = 0xC618;
  Button6.Color           = 0xC618;
  Button6.Press_Color     = 0xC618;
  Button6.OnUpPtr         = 0;
  Button6.OnDownPtr       = 0;
  Button6.OnClickPtr      = Button6OnClick;
  Button6.OnPressPtr      = 0;

  Line2.OwnerScreen     = &InfoScreen;
  Line2.Order           = 1;
  Line2.First_Point_X   = 0;
  Line2.First_Point_Y   = 20;
  Line2.Second_Point_X  = 320;
  Line2.Second_Point_Y  = 20;
  Line2.Visible         = 1;
  Line2.Pen_Width       = 1;
  Line2.Color           = 0x0000;

  BtAdresseLbl.OwnerScreen     = &InfoScreen;
  BtAdresseLbl.Order           = 2;
  BtAdresseLbl.Left            = 88;
  BtAdresseLbl.Top             = 33;
  BtAdresseLbl.Width           = 22;
  BtAdresseLbl.Height          = 15;
  BtAdresseLbl.Visible         = 1;
  BtAdresseLbl.Active          = 1;
  BtAdresseLbl.Caption         = BtAdresseLbl_Caption;
  BtAdresseLbl.FontName        = Tahoma11x13_Regular;
  BtAdresseLbl.Font_Color      = 0x0000;
  BtAdresseLbl.OnUpPtr         = 0;
  BtAdresseLbl.OnDownPtr       = 0;
  BtAdresseLbl.OnClickPtr      = 0;
  BtAdresseLbl.OnPressPtr      = 0;

  DevNameLbl.OwnerScreen     = &InfoScreen;
  DevNameLbl.Order           = 3;
  DevNameLbl.Left            = 88;
  DevNameLbl.Top             = 48;
  DevNameLbl.Width           = 22;
  DevNameLbl.Height          = 15;
  DevNameLbl.Visible         = 1;
  DevNameLbl.Active          = 1;
  DevNameLbl.Caption         = DevNameLbl_Caption;
  DevNameLbl.FontName        = Tahoma11x13_Regular;
  DevNameLbl.Font_Color      = 0x0000;
  DevNameLbl.OnUpPtr         = 0;
  DevNameLbl.OnDownPtr       = 0;
  DevNameLbl.OnClickPtr      = 0;
  DevNameLbl.OnPressPtr      = 0;

  ModeLbl.OwnerScreen     = &InfoScreen;
  ModeLbl.Order           = 4;
  ModeLbl.Left            = 88;
  ModeLbl.Top             = 62;
  ModeLbl.Width           = 22;
  ModeLbl.Height          = 15;
  ModeLbl.Visible         = 1;
  ModeLbl.Active          = 1;
  ModeLbl.Caption         = ModeLbl_Caption;
  ModeLbl.FontName        = Tahoma11x13_Regular;
  ModeLbl.Font_Color      = 0x0000;
  ModeLbl.OnUpPtr         = 0;
  ModeLbl.OnDownPtr       = 0;
  ModeLbl.OnClickPtr      = 0;
  ModeLbl.OnPressPtr      = 0;

  StatusLbl.OwnerScreen     = &InfoScreen;
  StatusLbl.Order           = 5;
  StatusLbl.Left            = 88;
  StatusLbl.Top             = 77;
  StatusLbl.Width           = 22;
  StatusLbl.Height          = 15;
  StatusLbl.Visible         = 1;
  StatusLbl.Active          = 1;
  StatusLbl.Caption         = StatusLbl_Caption;
  StatusLbl.FontName        = Tahoma11x13_Regular;
  StatusLbl.Font_Color      = 0x0000;
  StatusLbl.OnUpPtr         = 0;
  StatusLbl.OnDownPtr       = 0;
  StatusLbl.OnClickPtr      = 0;
  StatusLbl.OnPressPtr      = 0;

  AuthLbl.OwnerScreen     = &InfoScreen;
  AuthLbl.Order           = 6;
  AuthLbl.Left            = 88;
  AuthLbl.Top             = 92;
  AuthLbl.Width           = 22;
  AuthLbl.Height          = 15;
  AuthLbl.Visible         = 1;
  AuthLbl.Active          = 1;
  AuthLbl.Caption         = AuthLbl_Caption;
  AuthLbl.FontName        = Tahoma11x13_Regular;
  AuthLbl.Font_Color      = 0x0000;
  AuthLbl.OnUpPtr         = 0;
  AuthLbl.OnDownPtr       = 0;
  AuthLbl.OnClickPtr      = 0;
  AuthLbl.OnPressPtr      = 0;

  EncrLbl.OwnerScreen     = &InfoScreen;
  EncrLbl.Order           = 7;
  EncrLbl.Left            = 88;
  EncrLbl.Top             = 106;
  EncrLbl.Width           = 22;
  EncrLbl.Height          = 15;
  EncrLbl.Visible         = 1;
  EncrLbl.Active          = 1;
  EncrLbl.Caption         = EncrLbl_Caption;
  EncrLbl.FontName        = Tahoma11x13_Regular;
  EncrLbl.Font_Color      = 0x0000;
  EncrLbl.OnUpPtr         = 0;
  EncrLbl.OnDownPtr       = 0;
  EncrLbl.OnClickPtr      = 0;
  EncrLbl.OnPressPtr      = 0;

  FlowLbl.OwnerScreen     = &InfoScreen;
  FlowLbl.Order           = 8;
  FlowLbl.Left            = 88;
  FlowLbl.Top             = 121;
  FlowLbl.Width           = 22;
  FlowLbl.Height          = 15;
  FlowLbl.Visible         = 1;
  FlowLbl.Active          = 1;
  FlowLbl.Caption         = FlowLbl_Caption;
  FlowLbl.FontName        = Tahoma11x13_Regular;
  FlowLbl.Font_Color      = 0x0000;
  FlowLbl.OnUpPtr         = 0;
  FlowLbl.OnDownPtr       = 0;
  FlowLbl.OnClickPtr      = 0;
  FlowLbl.OnPressPtr      = 0;

  BackButton.OwnerScreen     = &InfoScreen;
  BackButton.Order           = 16;
  BackButton.Left            = 6;
  BackButton.Top             = 205;
  BackButton.Width           = 309;
  BackButton.Height          = 30;
  BackButton.Pen_Width       = 1;
  BackButton.Pen_Color       = 0x0000;
  BackButton.Visible         = 1;
  BackButton.Active          = 1;
  BackButton.Transparent     = 1;
  BackButton.Caption         = BackButton_Caption;
  BackButton.TextAlign       = _taCenter;
  BackButton.FontName        = Tahoma11x13_Regular;
  BackButton.PressColEnabled = 1;
  BackButton.Font_Color      = 0x0000;
  BackButton.Gradient        = 1;
  BackButton.Gradient_Orientation    = 0;
  BackButton.Gradient_Start_Color    = 0xFFFF;
  BackButton.Gradient_End_Color      = 0xC618;
  BackButton.Color           = 0xC618;
  BackButton.Press_Color     = 0xC618;
  BackButton.OnUpPtr         = 0;
  BackButton.OnDownPtr       = 0;
  BackButton.OnClickPtr      = BackButtonOnClick;
  BackButton.OnPressPtr      = 0;

  InqTitle.OwnerScreen     = &InqScreen;
  InqTitle.Order           = 1;
  InqTitle.Left            = 124;
  InqTitle.Top             = 6;
  InqTitle.Width           = 63;
  InqTitle.Height          = 15;
  InqTitle.Visible         = 1;
  InqTitle.Active          = 1;
  InqTitle.Caption         = InqTitle_Caption;
  InqTitle.FontName        = Tahoma11x13_Regular;
  InqTitle.Font_Color      = 0x0000;
  InqTitle.OnUpPtr         = 0;
  InqTitle.OnDownPtr       = 0;
  InqTitle.OnClickPtr      = 0;
  InqTitle.OnPressPtr      = 0;

  Line3.OwnerScreen     = &InqScreen;
  Line3.Order           = 2;
  Line3.First_Point_X   = 0;
  Line3.First_Point_Y   = 20;
  Line3.Second_Point_X  = 320;
  Line3.Second_Point_Y  = 20;
  Line3.Visible         = 1;
  Line3.Pen_Width       = 1;
  Line3.Color           = 0x0000;

  dev1.OwnerScreen     = &InqScreen;
  dev1.Order           = 5;
  dev1.Left            = 5;
  dev1.Top             = 25;
  dev1.Width           = 150;
  dev1.Height          = 21;
  dev1.Pen_Width       = 1;
  dev1.Pen_Color       = 0x0000;
  dev1.Visible         = 0;
  dev1.Active          = 1;
  dev1.Transparent     = 1;
  dev1.Caption         = dev1_Caption;
  dev1.TextAlign       = _taCenter;
  dev1.FontName        = Tahoma11x13_Regular;
  dev1.PressColEnabled = 1;
  dev1.Font_Color      = 0x0000;
  dev1.Gradient        = 1;
  dev1.Gradient_Orientation    = 0;
  dev1.Gradient_Start_Color    = 0xFFFF;
  dev1.Gradient_End_Color      = 0xC618;
  dev1.Color           = 0xC618;
  dev1.Press_Color     = 0xC618;
  dev1.OnUpPtr         = 0;
  dev1.OnDownPtr       = 0;
  dev1.OnClickPtr      = dev1OnClick;
  dev1.OnPressPtr      = 0;

  dev2.OwnerScreen     = &InqScreen;
  dev2.Order           = 6;
  dev2.Left            = 5;
  dev2.Top             = 46;
  dev2.Width           = 150;
  dev2.Height          = 21;
  dev2.Pen_Width       = 1;
  dev2.Pen_Color       = 0x0000;
  dev2.Visible         = 0;
  dev2.Active          = 1;
  dev2.Transparent     = 1;
  dev2.Caption         = dev2_Caption;
  dev2.TextAlign       = _taCenter;
  dev2.FontName        = Tahoma11x13_Regular;
  dev2.PressColEnabled = 1;
  dev2.Font_Color      = 0x0000;
  dev2.Gradient        = 1;
  dev2.Gradient_Orientation    = 0;
  dev2.Gradient_Start_Color    = 0xFFFF;
  dev2.Gradient_End_Color      = 0xC618;
  dev2.Color           = 0xC618;
  dev2.Press_Color     = 0xC618;
  dev2.OnUpPtr         = 0;
  dev2.OnDownPtr       = 0;
  dev2.OnClickPtr      = dev2OnClick;
  dev2.OnPressPtr      = 0;

  dev3.OwnerScreen     = &InqScreen;
  dev3.Order           = 7;
  dev3.Left            = 5;
  dev3.Top             = 67;
  dev3.Width           = 150;
  dev3.Height          = 21;
  dev3.Pen_Width       = 1;
  dev3.Pen_Color       = 0x0000;
  dev3.Visible         = 0;
  dev3.Active          = 1;
  dev3.Transparent     = 1;
  dev3.Caption         = dev3_Caption;
  dev3.TextAlign       = _taCenter;
  dev3.FontName        = Tahoma11x13_Regular;
  dev3.PressColEnabled = 1;
  dev3.Font_Color      = 0x0000;
  dev3.Gradient        = 1;
  dev3.Gradient_Orientation    = 0;
  dev3.Gradient_Start_Color    = 0xFFFF;
  dev3.Gradient_End_Color      = 0xC618;
  dev3.Color           = 0xC618;
  dev3.Press_Color     = 0xC618;
  dev3.OnUpPtr         = 0;
  dev3.OnDownPtr       = 0;
  dev3.OnClickPtr      = dev3OnClick;
  dev3.OnPressPtr      = 0;

  dev4.OwnerScreen     = &InqScreen;
  dev4.Order           = 8;
  dev4.Left            = 5;
  dev4.Top             = 88;
  dev4.Width           = 150;
  dev4.Height          = 21;
  dev4.Pen_Width       = 1;
  dev4.Pen_Color       = 0x0000;
  dev4.Visible         = 0;
  dev4.Active          = 1;
  dev4.Transparent     = 1;
  dev4.Caption         = dev4_Caption;
  dev4.TextAlign       = _taCenter;
  dev4.FontName        = Tahoma11x13_Regular;
  dev4.PressColEnabled = 1;
  dev4.Font_Color      = 0x0000;
  dev4.Gradient        = 1;
  dev4.Gradient_Orientation    = 0;
  dev4.Gradient_Start_Color    = 0xFFFF;
  dev4.Gradient_End_Color      = 0xC618;
  dev4.Color           = 0xC618;
  dev4.Press_Color     = 0xC618;
  dev4.OnUpPtr         = 0;
  dev4.OnDownPtr       = 0;
  dev4.OnClickPtr      = dev4OnClick;
  dev4.OnPressPtr      = 0;

  dev5.OwnerScreen     = &InqScreen;
  dev5.Order           = 9;
  dev5.Left            = 5;
  dev5.Top             = 109;
  dev5.Width           = 150;
  dev5.Height          = 21;
  dev5.Pen_Width       = 1;
  dev5.Pen_Color       = 0x0000;
  dev5.Visible         = 0;
  dev5.Active          = 1;
  dev5.Transparent     = 1;
  dev5.Caption         = dev5_Caption;
  dev5.TextAlign       = _taCenter;
  dev5.FontName        = Tahoma11x13_Regular;
  dev5.PressColEnabled = 1;
  dev5.Font_Color      = 0x0000;
  dev5.Gradient        = 1;
  dev5.Gradient_Orientation    = 0;
  dev5.Gradient_Start_Color    = 0xFFFF;
  dev5.Gradient_End_Color      = 0xC618;
  dev5.Color           = 0xC618;
  dev5.Press_Color     = 0xC618;
  dev5.OnUpPtr         = 0;
  dev5.OnDownPtr       = 0;
  dev5.OnClickPtr      = dev5OnClick;
  dev5.OnPressPtr      = 0;

  dev6.OwnerScreen     = &InqScreen;
  dev6.Order           = 10;
  dev6.Left            = 5;
  dev6.Top             = 130;
  dev6.Width           = 150;
  dev6.Height          = 21;
  dev6.Pen_Width       = 1;
  dev6.Pen_Color       = 0x0000;
  dev6.Visible         = 0;
  dev6.Active          = 1;
  dev6.Transparent     = 1;
  dev6.Caption         = dev6_Caption;
  dev6.TextAlign       = _taCenter;
  dev6.FontName        = Tahoma11x13_Regular;
  dev6.PressColEnabled = 1;
  dev6.Font_Color      = 0x0000;
  dev6.Gradient        = 1;
  dev6.Gradient_Orientation    = 0;
  dev6.Gradient_Start_Color    = 0xFFFF;
  dev6.Gradient_End_Color      = 0xC618;
  dev6.Color           = 0xC618;
  dev6.Press_Color     = 0xC618;
  dev6.OnUpPtr         = 0;
  dev6.OnDownPtr       = 0;
  dev6.OnClickPtr      = dev6OnClick;
  dev6.OnPressPtr      = 0;

  dev7.OwnerScreen     = &InqScreen;
  dev7.Order           = 11;
  dev7.Left            = 5;
  dev7.Top             = 151;
  dev7.Width           = 150;
  dev7.Height          = 21;
  dev7.Pen_Width       = 1;
  dev7.Pen_Color       = 0x0000;
  dev7.Visible         = 0;
  dev7.Active          = 1;
  dev7.Transparent     = 1;
  dev7.Caption         = dev7_Caption;
  dev7.TextAlign       = _taCenter;
  dev7.FontName        = Tahoma11x13_Regular;
  dev7.PressColEnabled = 1;
  dev7.Font_Color      = 0x0000;
  dev7.Gradient        = 1;
  dev7.Gradient_Orientation    = 0;
  dev7.Gradient_Start_Color    = 0xFFFF;
  dev7.Gradient_End_Color      = 0xC618;
  dev7.Color           = 0xC618;
  dev7.Press_Color     = 0xC618;
  dev7.OnUpPtr         = 0;
  dev7.OnDownPtr       = 0;
  dev7.OnClickPtr      = dev7OnClick;
  dev7.OnPressPtr      = 0;

  dev8.OwnerScreen     = &InqScreen;
  dev8.Order           = 12;
  dev8.Left            = 5;
  dev8.Top             = 172;
  dev8.Width           = 150;
  dev8.Height          = 21;
  dev8.Pen_Width       = 1;
  dev8.Pen_Color       = 0x0000;
  dev8.Visible         = 0;
  dev8.Active          = 1;
  dev8.Transparent     = 1;
  dev8.Caption         = dev8_Caption;
  dev8.TextAlign       = _taCenter;
  dev8.FontName        = Tahoma11x13_Regular;
  dev8.PressColEnabled = 1;
  dev8.Font_Color      = 0x0000;
  dev8.Gradient        = 1;
  dev8.Gradient_Orientation    = 0;
  dev8.Gradient_Start_Color    = 0xFFFF;
  dev8.Gradient_End_Color      = 0xC618;
  dev8.Color           = 0xC618;
  dev8.Press_Color     = 0xC618;
  dev8.OnUpPtr         = 0;
  dev8.OnDownPtr       = 0;
  dev8.OnClickPtr      = dev8OnClick;
  dev8.OnPressPtr      = 0;

  dev9.OwnerScreen     = &InqScreen;
  dev9.Order           = 13;
  dev9.Left            = 165;
  dev9.Top             = 25;
  dev9.Width           = 150;
  dev9.Height          = 21;
  dev9.Pen_Width       = 1;
  dev9.Pen_Color       = 0x0000;
  dev9.Visible         = 0;
  dev9.Active          = 1;
  dev9.Transparent     = 1;
  dev9.Caption         = dev9_Caption;
  dev9.TextAlign       = _taCenter;
  dev9.FontName        = Tahoma11x13_Regular;
  dev9.PressColEnabled = 1;
  dev9.Font_Color      = 0x0000;
  dev9.Gradient        = 1;
  dev9.Gradient_Orientation    = 0;
  dev9.Gradient_Start_Color    = 0xFFFF;
  dev9.Gradient_End_Color      = 0xC618;
  dev9.Color           = 0xC618;
  dev9.Press_Color     = 0xC618;
  dev9.OnUpPtr         = 0;
  dev9.OnDownPtr       = 0;
  dev9.OnClickPtr      = dev9OnClick;
  dev9.OnPressPtr      = 0;

  dev10.OwnerScreen     = &InqScreen;
  dev10.Order           = 14;
  dev10.Left            = 165;
  dev10.Top             = 46;
  dev10.Width           = 150;
  dev10.Height          = 21;
  dev10.Pen_Width       = 1;
  dev10.Pen_Color       = 0x0000;
  dev10.Visible         = 0;
  dev10.Active          = 1;
  dev10.Transparent     = 1;
  dev10.Caption         = dev10_Caption;
  dev10.TextAlign       = _taCenter;
  dev10.FontName        = Tahoma11x13_Regular;
  dev10.PressColEnabled = 1;
  dev10.Font_Color      = 0x0000;
  dev10.Gradient        = 1;
  dev10.Gradient_Orientation    = 0;
  dev10.Gradient_Start_Color    = 0xFFFF;
  dev10.Gradient_End_Color      = 0xC618;
  dev10.Color           = 0xC618;
  dev10.Press_Color     = 0xC618;
  dev10.OnUpPtr         = 0;
  dev10.OnDownPtr       = 0;
  dev10.OnClickPtr      = dev10OnClick;
  dev10.OnPressPtr      = 0;

  dev11.OwnerScreen     = &InqScreen;
  dev11.Order           = 15;
  dev11.Left            = 165;
  dev11.Top             = 67;
  dev11.Width           = 150;
  dev11.Height          = 21;
  dev11.Pen_Width       = 1;
  dev11.Pen_Color       = 0x0000;
  dev11.Visible         = 0;
  dev11.Active          = 1;
  dev11.Transparent     = 1;
  dev11.Caption         = dev11_Caption;
  dev11.TextAlign       = _taCenter;
  dev11.FontName        = Tahoma11x13_Regular;
  dev11.PressColEnabled = 1;
  dev11.Font_Color      = 0x0000;
  dev11.Gradient        = 1;
  dev11.Gradient_Orientation    = 0;
  dev11.Gradient_Start_Color    = 0xFFFF;
  dev11.Gradient_End_Color      = 0xC618;
  dev11.Color           = 0xC618;
  dev11.Press_Color     = 0xC618;
  dev11.OnUpPtr         = 0;
  dev11.OnDownPtr       = 0;
  dev11.OnClickPtr      = dev11OnClick;
  dev11.OnPressPtr      = 0;

  dev12.OwnerScreen     = &InqScreen;
  dev12.Order           = 16;
  dev12.Left            = 165;
  dev12.Top             = 88;
  dev12.Width           = 150;
  dev12.Height          = 21;
  dev12.Pen_Width       = 1;
  dev12.Pen_Color       = 0x0000;
  dev12.Visible         = 0;
  dev12.Active          = 1;
  dev12.Transparent     = 1;
  dev12.Caption         = dev12_Caption;
  dev12.TextAlign       = _taCenter;
  dev12.FontName        = Tahoma11x13_Regular;
  dev12.PressColEnabled = 1;
  dev12.Font_Color      = 0x0000;
  dev12.Gradient        = 1;
  dev12.Gradient_Orientation    = 0;
  dev12.Gradient_Start_Color    = 0xFFFF;
  dev12.Gradient_End_Color      = 0xC618;
  dev12.Color           = 0xC618;
  dev12.Press_Color     = 0xC618;
  dev12.OnUpPtr         = 0;
  dev12.OnDownPtr       = 0;
  dev12.OnClickPtr      = dev12OnClick;
  dev12.OnPressPtr      = 0;

  dev13.OwnerScreen     = &InqScreen;
  dev13.Order           = 17;
  dev13.Left            = 165;
  dev13.Top             = 109;
  dev13.Width           = 150;
  dev13.Height          = 21;
  dev13.Pen_Width       = 1;
  dev13.Pen_Color       = 0x0000;
  dev13.Visible         = 0;
  dev13.Active          = 1;
  dev13.Transparent     = 1;
  dev13.Caption         = dev13_Caption;
  dev13.TextAlign       = _taCenter;
  dev13.FontName        = Tahoma11x13_Regular;
  dev13.PressColEnabled = 1;
  dev13.Font_Color      = 0x0000;
  dev13.Gradient        = 1;
  dev13.Gradient_Orientation    = 0;
  dev13.Gradient_Start_Color    = 0xFFFF;
  dev13.Gradient_End_Color      = 0xC618;
  dev13.Color           = 0xC618;
  dev13.Press_Color     = 0xC618;
  dev13.OnUpPtr         = 0;
  dev13.OnDownPtr       = 0;
  dev13.OnClickPtr      = dev13OnClick;
  dev13.OnPressPtr      = 0;

  dev14.OwnerScreen     = &InqScreen;
  dev14.Order           = 18;
  dev14.Left            = 165;
  dev14.Top             = 130;
  dev14.Width           = 150;
  dev14.Height          = 21;
  dev14.Pen_Width       = 1;
  dev14.Pen_Color       = 0x0000;
  dev14.Visible         = 0;
  dev14.Active          = 1;
  dev14.Transparent     = 1;
  dev14.Caption         = dev14_Caption;
  dev14.TextAlign       = _taCenter;
  dev14.FontName        = Tahoma11x13_Regular;
  dev14.PressColEnabled = 1;
  dev14.Font_Color      = 0x0000;
  dev14.Gradient        = 1;
  dev14.Gradient_Orientation    = 0;
  dev14.Gradient_Start_Color    = 0xFFFF;
  dev14.Gradient_End_Color      = 0xC618;
  dev14.Color           = 0xC618;
  dev14.Press_Color     = 0xC618;
  dev14.OnUpPtr         = 0;
  dev14.OnDownPtr       = 0;
  dev14.OnClickPtr      = dev14OnClick;
  dev14.OnPressPtr      = 0;

  dev15.OwnerScreen     = &InqScreen;
  dev15.Order           = 19;
  dev15.Left            = 165;
  dev15.Top             = 151;
  dev15.Width           = 150;
  dev15.Height          = 21;
  dev15.Pen_Width       = 1;
  dev15.Pen_Color       = 0x0000;
  dev15.Visible         = 0;
  dev15.Active          = 1;
  dev15.Transparent     = 1;
  dev15.Caption         = dev15_Caption;
  dev15.TextAlign       = _taCenter;
  dev15.FontName        = Tahoma11x13_Regular;
  dev15.PressColEnabled = 1;
  dev15.Font_Color      = 0x0000;
  dev15.Gradient        = 1;
  dev15.Gradient_Orientation    = 0;
  dev15.Gradient_Start_Color    = 0xFFFF;
  dev15.Gradient_End_Color      = 0xC618;
  dev15.Color           = 0xC618;
  dev15.Press_Color     = 0xC618;
  dev15.OnUpPtr         = 0;
  dev15.OnDownPtr       = 0;
  dev15.OnClickPtr      = dev15OnClick;
  dev15.OnPressPtr      = 0;

  Label8.OwnerScreen     = &ConErrorScreen;
  Label8.Order           = 0;
  Label8.Left            = 49;
  Label8.Top             = 59;
  Label8.Width           = 223;
  Label8.Height          = 36;
  Label8.Visible         = 1;
  Label8.Active          = 1;
  Label8.Caption         = Label8_Caption;
  Label8.FontName        = Tahoma26x33_Regular;
  Label8.Font_Color      = 0xFFFF;
  Label8.OnUpPtr         = 0;
  Label8.OnDownPtr       = 0;
  Label8.OnClickPtr      = 0;
  Label8.OnPressPtr      = 0;

  OkButton.OwnerScreen     = &ConErrorScreen;
  OkButton.Order           = 1;
  OkButton.Left            = 98;
  OkButton.Top             = 126;
  OkButton.Width           = 123;
  OkButton.Height          = 30;
  OkButton.Pen_Width       = 1;
  OkButton.Pen_Color       = 0x0000;
  OkButton.Visible         = 1;
  OkButton.Active          = 1;
  OkButton.Transparent     = 1;
  OkButton.Caption         = OkButton_Caption;
  OkButton.TextAlign       = _taCenter;
  OkButton.FontName        = Tahoma11x13_Regular;
  OkButton.PressColEnabled = 1;
  OkButton.Font_Color      = 0x0000;
  OkButton.Gradient        = 1;
  OkButton.Gradient_Orientation    = 0;
  OkButton.Gradient_Start_Color    = 0xFFFF;
  OkButton.Gradient_End_Color      = 0xC618;
  OkButton.Color           = 0xC618;
  OkButton.Press_Color     = 0x8410;
  OkButton.Corner_Radius   = 3;
  OkButton.OnUpPtr         = 0;
  OkButton.OnDownPtr       = 0;
  OkButton.OnClickPtr      = OkButtonOnClick;
  OkButton.OnPressPtr      = 0;

  Label10.OwnerScreen     = &ConErrorScreen;
  Label10.Order           = 2;
  Label10.Left            = 5;
  Label10.Top             = 220;
  Label10.Width           = 22;
  Label10.Height          = 15;
  Label10.Visible         = 1;
  Label10.Active          = 1;
  Label10.Caption         = Label10_Caption;
  Label10.FontName        = Tahoma11x13_Regular;
  Label10.Font_Color      = 0x0000;
  Label10.OnUpPtr         = 0;
  Label10.OnDownPtr       = 0;
  Label10.OnClickPtr      = 0;
  Label10.OnPressPtr      = 0;

  SuccessLabel.OwnerScreen     = &ConSuccessScreen;
  SuccessLabel.Order           = 0;
  SuccessLabel.Left            = 38;
  SuccessLabel.Top             = 99;
  SuccessLabel.Width           = 243;
  SuccessLabel.Height          = 28;
  SuccessLabel.Visible         = 1;
  SuccessLabel.Active          = 1;
  SuccessLabel.Caption         = SuccessLabel_Caption;
  SuccessLabel.FontName        = Tahoma21x25_Regular;
  SuccessLabel.Font_Color      = 0xFFFF;
  SuccessLabel.OnUpPtr         = 0;
  SuccessLabel.OnDownPtr       = 0;
  SuccessLabel.OnClickPtr      = 0;
  SuccessLabel.OnPressPtr      = 0;

  ButtonRound1.OwnerScreen     = &DiscoScreen;
  ButtonRound1.Order           = 1;
  ButtonRound1.Left            = 40;
  ButtonRound1.Top             = 126;
  ButtonRound1.Width           = 100;
  ButtonRound1.Height          = 30;
  ButtonRound1.Pen_Width       = 1;
  ButtonRound1.Pen_Color       = 0x0000;
  ButtonRound1.Visible         = 1;
  ButtonRound1.Active          = 1;
  ButtonRound1.Transparent     = 1;
  ButtonRound1.Caption         = ButtonRound1_Caption;
  ButtonRound1.TextAlign       = _taCenter;
  ButtonRound1.FontName        = Tahoma11x13_Regular;
  ButtonRound1.PressColEnabled = 1;
  ButtonRound1.Font_Color      = 0x0000;
  ButtonRound1.Gradient        = 1;
  ButtonRound1.Gradient_Orientation    = 0;
  ButtonRound1.Gradient_Start_Color    = 0xFFFF;
  ButtonRound1.Gradient_End_Color      = 0xC618;
  ButtonRound1.Color           = 0xC618;
  ButtonRound1.Press_Color     = 0x8410;
  ButtonRound1.Corner_Radius   = 3;
  ButtonRound1.OnUpPtr         = 0;
  ButtonRound1.OnDownPtr       = 0;
  ButtonRound1.OnClickPtr      = BackButtonOnClick;
  ButtonRound1.OnPressPtr      = 0;

  DiscoButton.OwnerScreen     = &DiscoScreen;
  DiscoButton.Order           = 2;
  DiscoButton.Left            = 180;
  DiscoButton.Top             = 126;
  DiscoButton.Width           = 100;
  DiscoButton.Height          = 30;
  DiscoButton.Pen_Width       = 1;
  DiscoButton.Pen_Color       = 0x0000;
  DiscoButton.Visible         = 1;
  DiscoButton.Active          = 1;
  DiscoButton.Transparent     = 1;
  DiscoButton.Caption         = DiscoButton_Caption;
  DiscoButton.TextAlign       = _taCenter;
  DiscoButton.FontName        = Tahoma11x13_Regular;
  DiscoButton.PressColEnabled = 1;
  DiscoButton.Font_Color      = 0x0000;
  DiscoButton.Gradient        = 1;
  DiscoButton.Gradient_Orientation    = 0;
  DiscoButton.Gradient_Start_Color    = 0xFFFF;
  DiscoButton.Gradient_End_Color      = 0xC618;
  DiscoButton.Color           = 0xC618;
  DiscoButton.Press_Color     = 0x8410;
  DiscoButton.Corner_Radius   = 3;
  DiscoButton.OnUpPtr         = 0;
  DiscoButton.OnDownPtr       = 0;
  DiscoButton.OnClickPtr      = DiscoButtonOnClick;
  DiscoButton.OnPressPtr      = 0;

  Line4.OwnerScreen     = &PinCode;
  Line4.Order           = 0;
  Line4.First_Point_X   = 0;
  Line4.First_Point_Y   = 20;
  Line4.Second_Point_X  = 320;
  Line4.Second_Point_Y  = 20;
  Line4.Visible         = 1;
  Line4.Pen_Width       = 1;
  Line4.Color           = 0x0000;

  cache_pin_str.OwnerScreen     = &PinCode;
  cache_pin_str.Order           = 2;
  cache_pin_str.Left            = 5;
  cache_pin_str.Top             = 30;
  cache_pin_str.Width           = 310;
  cache_pin_str.Height          = 20;
  cache_pin_str.Pen_Width       = 1;
  cache_pin_str.Pen_Color       = 0x0000;
  cache_pin_str.Visible         = 1;
  cache_pin_str.Active          = 0;
  cache_pin_str.Transparent     = 1;
  cache_pin_str.Gradient        = 0;
  cache_pin_str.Gradient_Orientation    = 0;
  cache_pin_str.Gradient_Start_Color    = 0xFFFF;
  cache_pin_str.Gradient_End_Color      = 0xC618;
  cache_pin_str.Color           = 0xEF5D;
  cache_pin_str.PressColEnabled     = 1;
  cache_pin_str.Press_Color     = 0x8410;
  cache_pin_str.OnUpPtr         = 0;
  cache_pin_str.OnDownPtr       = 0;
  cache_pin_str.OnClickPtr      = 0;
  cache_pin_str.OnPressPtr      = 0;

  TextField.OwnerScreen     = &PinCode;
  TextField.Order           = 3;
  TextField.Left            = 10;
  TextField.Top             = 33;
  TextField.Width           = 0;
  TextField.Height          = 0;
  TextField.Visible         = 1;
  TextField.Active          = 1;
  TextField.Caption         = TextField_Caption;
  TextField.FontName        = Tahoma11x13_Regular;
  TextField.Font_Color      = 0x0000;
  TextField.OnUpPtr         = 0;
  TextField.OnDownPtr       = 0;
  TextField.OnClickPtr      = 0;
  TextField.OnPressPtr      = 0;

  key_a.OwnerScreen     = &PinCode;
  key_a.Order           = 4;
  key_a.Left            = 9;
  key_a.Top             = 102;
  key_a.Width           = 30;
  key_a.Height          = 30;
  key_a.Pen_Width       = 1;
  key_a.Pen_Color       = 0x0000;
  key_a.Visible         = 1;
  key_a.Active          = 1;
  key_a.Transparent     = 1;
  key_a.Caption         = key_a_Caption;
  key_a.TextAlign       = _taCenter;
  key_a.FontName        = Tahoma11x13_Regular;
  key_a.PressColEnabled = 1;
  key_a.Font_Color      = 0x0000;
  key_a.Gradient        = 1;
  key_a.Gradient_Orientation    = 0;
  key_a.Gradient_Start_Color    = 0xFFFF;
  key_a.Gradient_End_Color      = 0xC618;
  key_a.Color           = 0xC618;
  key_a.Press_Color     = 0x8410;
  key_a.Corner_Radius   = 3;
  key_a.OnUpPtr         = 0;
  key_a.OnDownPtr       = 0;
  key_a.OnClickPtr      = key_aOnClick;
  key_a.OnPressPtr      = 0;

  key_z.OwnerScreen     = &PinCode;
  key_z.Order           = 5;
  key_z.Left            = 39;
  key_z.Top             = 102;
  key_z.Width           = 30;
  key_z.Height          = 30;
  key_z.Pen_Width       = 1;
  key_z.Pen_Color       = 0x0000;
  key_z.Visible         = 1;
  key_z.Active          = 1;
  key_z.Transparent     = 1;
  key_z.Caption         = key_z_Caption;
  key_z.TextAlign       = _taCenter;
  key_z.FontName        = Tahoma11x13_Regular;
  key_z.PressColEnabled = 1;
  key_z.Font_Color      = 0x0000;
  key_z.Gradient        = 1;
  key_z.Gradient_Orientation    = 0;
  key_z.Gradient_Start_Color    = 0xFFFF;
  key_z.Gradient_End_Color      = 0xC618;
  key_z.Color           = 0xC618;
  key_z.Press_Color     = 0x8410;
  key_z.Corner_Radius   = 3;
  key_z.OnUpPtr         = 0;
  key_z.OnDownPtr       = 0;
  key_z.OnClickPtr      = key_zOnClick;
  key_z.OnPressPtr      = 0;

  key_e.OwnerScreen     = &PinCode;
  key_e.Order           = 6;
  key_e.Left            = 69;
  key_e.Top             = 102;
  key_e.Width           = 30;
  key_e.Height          = 30;
  key_e.Pen_Width       = 1;
  key_e.Pen_Color       = 0x0000;
  key_e.Visible         = 1;
  key_e.Active          = 1;
  key_e.Transparent     = 1;
  key_e.Caption         = key_e_Caption;
  key_e.TextAlign       = _taCenter;
  key_e.FontName        = Tahoma11x13_Regular;
  key_e.PressColEnabled = 1;
  key_e.Font_Color      = 0x0000;
  key_e.Gradient        = 1;
  key_e.Gradient_Orientation    = 0;
  key_e.Gradient_Start_Color    = 0xFFFF;
  key_e.Gradient_End_Color      = 0xC618;
  key_e.Color           = 0xC618;
  key_e.Press_Color     = 0x8410;
  key_e.Corner_Radius   = 3;
  key_e.OnUpPtr         = 0;
  key_e.OnDownPtr       = 0;
  key_e.OnClickPtr      = key_eOnClick;
  key_e.OnPressPtr      = 0;

  key_r.OwnerScreen     = &PinCode;
  key_r.Order           = 7;
  key_r.Left            = 99;
  key_r.Top             = 102;
  key_r.Width           = 30;
  key_r.Height          = 30;
  key_r.Pen_Width       = 1;
  key_r.Pen_Color       = 0x0000;
  key_r.Visible         = 1;
  key_r.Active          = 1;
  key_r.Transparent     = 1;
  key_r.Caption         = key_r_Caption;
  key_r.TextAlign       = _taCenter;
  key_r.FontName        = Tahoma11x13_Regular;
  key_r.PressColEnabled = 1;
  key_r.Font_Color      = 0x0000;
  key_r.Gradient        = 1;
  key_r.Gradient_Orientation    = 0;
  key_r.Gradient_Start_Color    = 0xFFFF;
  key_r.Gradient_End_Color      = 0xC618;
  key_r.Color           = 0xC618;
  key_r.Press_Color     = 0x8410;
  key_r.Corner_Radius   = 3;
  key_r.OnUpPtr         = 0;
  key_r.OnDownPtr       = 0;
  key_r.OnClickPtr      = key_rOnClick;
  key_r.OnPressPtr      = 0;

  key_t.OwnerScreen     = &PinCode;
  key_t.Order           = 8;
  key_t.Left            = 129;
  key_t.Top             = 102;
  key_t.Width           = 30;
  key_t.Height          = 30;
  key_t.Pen_Width       = 1;
  key_t.Pen_Color       = 0x0000;
  key_t.Visible         = 1;
  key_t.Active          = 1;
  key_t.Transparent     = 1;
  key_t.Caption         = key_t_Caption;
  key_t.TextAlign       = _taCenter;
  key_t.FontName        = Tahoma11x13_Regular;
  key_t.PressColEnabled = 1;
  key_t.Font_Color      = 0x0000;
  key_t.Gradient        = 1;
  key_t.Gradient_Orientation    = 0;
  key_t.Gradient_Start_Color    = 0xFFFF;
  key_t.Gradient_End_Color      = 0xC618;
  key_t.Color           = 0xC618;
  key_t.Press_Color     = 0x8410;
  key_t.Corner_Radius   = 3;
  key_t.OnUpPtr         = 0;
  key_t.OnDownPtr       = 0;
  key_t.OnClickPtr      = key_tOnClick;
  key_t.OnPressPtr      = 0;

  key_y.OwnerScreen     = &PinCode;
  key_y.Order           = 9;
  key_y.Left            = 159;
  key_y.Top             = 102;
  key_y.Width           = 30;
  key_y.Height          = 30;
  key_y.Pen_Width       = 1;
  key_y.Pen_Color       = 0x0000;
  key_y.Visible         = 1;
  key_y.Active          = 1;
  key_y.Transparent     = 1;
  key_y.Caption         = key_y_Caption;
  key_y.TextAlign       = _taCenter;
  key_y.FontName        = Tahoma11x13_Regular;
  key_y.PressColEnabled = 1;
  key_y.Font_Color      = 0x0000;
  key_y.Gradient        = 1;
  key_y.Gradient_Orientation    = 0;
  key_y.Gradient_Start_Color    = 0xFFFF;
  key_y.Gradient_End_Color      = 0xC618;
  key_y.Color           = 0xC618;
  key_y.Press_Color     = 0x8410;
  key_y.Corner_Radius   = 3;
  key_y.OnUpPtr         = 0;
  key_y.OnDownPtr       = 0;
  key_y.OnClickPtr      = key_yOnClick;
  key_y.OnPressPtr      = 0;

  key_u.OwnerScreen     = &PinCode;
  key_u.Order           = 10;
  key_u.Left            = 189;
  key_u.Top             = 102;
  key_u.Width           = 30;
  key_u.Height          = 30;
  key_u.Pen_Width       = 1;
  key_u.Pen_Color       = 0x0000;
  key_u.Visible         = 1;
  key_u.Active          = 1;
  key_u.Transparent     = 1;
  key_u.Caption         = key_u_Caption;
  key_u.TextAlign       = _taCenter;
  key_u.FontName        = Tahoma11x13_Regular;
  key_u.PressColEnabled = 1;
  key_u.Font_Color      = 0x0000;
  key_u.Gradient        = 1;
  key_u.Gradient_Orientation    = 0;
  key_u.Gradient_Start_Color    = 0xFFFF;
  key_u.Gradient_End_Color      = 0xC618;
  key_u.Color           = 0xC618;
  key_u.Press_Color     = 0x8410;
  key_u.Corner_Radius   = 3;
  key_u.OnUpPtr         = 0;
  key_u.OnDownPtr       = 0;
  key_u.OnClickPtr      = key_uOnClick;
  key_u.OnPressPtr      = 0;

  key_i.OwnerScreen     = &PinCode;
  key_i.Order           = 11;
  key_i.Left            = 219;
  key_i.Top             = 102;
  key_i.Width           = 30;
  key_i.Height          = 30;
  key_i.Pen_Width       = 1;
  key_i.Pen_Color       = 0x0000;
  key_i.Visible         = 1;
  key_i.Active          = 1;
  key_i.Transparent     = 1;
  key_i.Caption         = key_i_Caption;
  key_i.TextAlign       = _taCenter;
  key_i.FontName        = Tahoma11x13_Regular;
  key_i.PressColEnabled = 1;
  key_i.Font_Color      = 0x0000;
  key_i.Gradient        = 1;
  key_i.Gradient_Orientation    = 0;
  key_i.Gradient_Start_Color    = 0xFFFF;
  key_i.Gradient_End_Color      = 0xC618;
  key_i.Color           = 0xC618;
  key_i.Press_Color     = 0x8410;
  key_i.Corner_Radius   = 3;
  key_i.OnUpPtr         = 0;
  key_i.OnDownPtr       = 0;
  key_i.OnClickPtr      = key_iOnClick;
  key_i.OnPressPtr      = 0;

  key_o.OwnerScreen     = &PinCode;
  key_o.Order           = 12;
  key_o.Left            = 249;
  key_o.Top             = 102;
  key_o.Width           = 30;
  key_o.Height          = 30;
  key_o.Pen_Width       = 1;
  key_o.Pen_Color       = 0x0000;
  key_o.Visible         = 1;
  key_o.Active          = 1;
  key_o.Transparent     = 1;
  key_o.Caption         = key_o_Caption;
  key_o.TextAlign       = _taCenter;
  key_o.FontName        = Tahoma11x13_Regular;
  key_o.PressColEnabled = 1;
  key_o.Font_Color      = 0x0000;
  key_o.Gradient        = 1;
  key_o.Gradient_Orientation    = 0;
  key_o.Gradient_Start_Color    = 0xFFFF;
  key_o.Gradient_End_Color      = 0xC618;
  key_o.Color           = 0xC618;
  key_o.Press_Color     = 0x8410;
  key_o.Corner_Radius   = 3;
  key_o.OnUpPtr         = 0;
  key_o.OnDownPtr       = 0;
  key_o.OnClickPtr      = key_oOnClick;
  key_o.OnPressPtr      = 0;

  key_p.OwnerScreen     = &PinCode;
  key_p.Order           = 13;
  key_p.Left            = 279;
  key_p.Top             = 102;
  key_p.Width           = 30;
  key_p.Height          = 30;
  key_p.Pen_Width       = 1;
  key_p.Pen_Color       = 0x0000;
  key_p.Visible         = 1;
  key_p.Active          = 1;
  key_p.Transparent     = 1;
  key_p.Caption         = key_p_Caption;
  key_p.TextAlign       = _taCenter;
  key_p.FontName        = Tahoma11x13_Regular;
  key_p.PressColEnabled = 1;
  key_p.Font_Color      = 0x0000;
  key_p.Gradient        = 1;
  key_p.Gradient_Orientation    = 0;
  key_p.Gradient_Start_Color    = 0xFFFF;
  key_p.Gradient_End_Color      = 0xC618;
  key_p.Color           = 0xC618;
  key_p.Press_Color     = 0x8410;
  key_p.Corner_Radius   = 3;
  key_p.OnUpPtr         = 0;
  key_p.OnDownPtr       = 0;
  key_p.OnClickPtr      = key_pOnClick;
  key_p.OnPressPtr      = 0;

  key_q.OwnerScreen     = &PinCode;
  key_q.Order           = 14;
  key_q.Left            = 9;
  key_q.Top             = 132;
  key_q.Width           = 30;
  key_q.Height          = 30;
  key_q.Pen_Width       = 1;
  key_q.Pen_Color       = 0x0000;
  key_q.Visible         = 1;
  key_q.Active          = 1;
  key_q.Transparent     = 1;
  key_q.Caption         = key_q_Caption;
  key_q.TextAlign       = _taCenter;
  key_q.FontName        = Tahoma11x13_Regular;
  key_q.PressColEnabled = 1;
  key_q.Font_Color      = 0x0000;
  key_q.Gradient        = 1;
  key_q.Gradient_Orientation    = 0;
  key_q.Gradient_Start_Color    = 0xFFFF;
  key_q.Gradient_End_Color      = 0xC618;
  key_q.Color           = 0xC618;
  key_q.Press_Color     = 0x8410;
  key_q.Corner_Radius   = 3;
  key_q.OnUpPtr         = 0;
  key_q.OnDownPtr       = 0;
  key_q.OnClickPtr      = key_qOnClick;
  key_q.OnPressPtr      = 0;

  key_s.OwnerScreen     = &PinCode;
  key_s.Order           = 15;
  key_s.Left            = 39;
  key_s.Top             = 132;
  key_s.Width           = 30;
  key_s.Height          = 30;
  key_s.Pen_Width       = 1;
  key_s.Pen_Color       = 0x0000;
  key_s.Visible         = 1;
  key_s.Active          = 1;
  key_s.Transparent     = 1;
  key_s.Caption         = key_s_Caption;
  key_s.TextAlign       = _taCenter;
  key_s.FontName        = Tahoma11x13_Regular;
  key_s.PressColEnabled = 1;
  key_s.Font_Color      = 0x0000;
  key_s.Gradient        = 1;
  key_s.Gradient_Orientation    = 0;
  key_s.Gradient_Start_Color    = 0xFFFF;
  key_s.Gradient_End_Color      = 0xC618;
  key_s.Color           = 0xC618;
  key_s.Press_Color     = 0x8410;
  key_s.Corner_Radius   = 3;
  key_s.OnUpPtr         = 0;
  key_s.OnDownPtr       = 0;
  key_s.OnClickPtr      = key_sOnClick;
  key_s.OnPressPtr      = 0;

  key_d.OwnerScreen     = &PinCode;
  key_d.Order           = 16;
  key_d.Left            = 69;
  key_d.Top             = 132;
  key_d.Width           = 30;
  key_d.Height          = 30;
  key_d.Pen_Width       = 1;
  key_d.Pen_Color       = 0x0000;
  key_d.Visible         = 1;
  key_d.Active          = 1;
  key_d.Transparent     = 1;
  key_d.Caption         = key_d_Caption;
  key_d.TextAlign       = _taCenter;
  key_d.FontName        = Tahoma11x13_Regular;
  key_d.PressColEnabled = 1;
  key_d.Font_Color      = 0x0000;
  key_d.Gradient        = 1;
  key_d.Gradient_Orientation    = 0;
  key_d.Gradient_Start_Color    = 0xFFFF;
  key_d.Gradient_End_Color      = 0xC618;
  key_d.Color           = 0xC618;
  key_d.Press_Color     = 0x8410;
  key_d.Corner_Radius   = 3;
  key_d.OnUpPtr         = 0;
  key_d.OnDownPtr       = 0;
  key_d.OnClickPtr      = key_dOnClick;
  key_d.OnPressPtr      = 0;

  key_f.OwnerScreen     = &PinCode;
  key_f.Order           = 17;
  key_f.Left            = 99;
  key_f.Top             = 132;
  key_f.Width           = 30;
  key_f.Height          = 30;
  key_f.Pen_Width       = 1;
  key_f.Pen_Color       = 0x0000;
  key_f.Visible         = 1;
  key_f.Active          = 1;
  key_f.Transparent     = 1;
  key_f.Caption         = key_f_Caption;
  key_f.TextAlign       = _taCenter;
  key_f.FontName        = Tahoma11x13_Regular;
  key_f.PressColEnabled = 1;
  key_f.Font_Color      = 0x0000;
  key_f.Gradient        = 1;
  key_f.Gradient_Orientation    = 0;
  key_f.Gradient_Start_Color    = 0xFFFF;
  key_f.Gradient_End_Color      = 0xC618;
  key_f.Color           = 0xC618;
  key_f.Press_Color     = 0x8410;
  key_f.Corner_Radius   = 3;
  key_f.OnUpPtr         = 0;
  key_f.OnDownPtr       = 0;
  key_f.OnClickPtr      = key_fOnClick;
  key_f.OnPressPtr      = 0;

  key_g.OwnerScreen     = &PinCode;
  key_g.Order           = 18;
  key_g.Left            = 129;
  key_g.Top             = 132;
  key_g.Width           = 30;
  key_g.Height          = 30;
  key_g.Pen_Width       = 1;
  key_g.Pen_Color       = 0x0000;
  key_g.Visible         = 1;
  key_g.Active          = 1;
  key_g.Transparent     = 1;
  key_g.Caption         = key_g_Caption;
  key_g.TextAlign       = _taCenter;
  key_g.FontName        = Tahoma11x13_Regular;
  key_g.PressColEnabled = 1;
  key_g.Font_Color      = 0x0000;
  key_g.Gradient        = 1;
  key_g.Gradient_Orientation    = 0;
  key_g.Gradient_Start_Color    = 0xFFFF;
  key_g.Gradient_End_Color      = 0xC618;
  key_g.Color           = 0xC618;
  key_g.Press_Color     = 0x8410;
  key_g.Corner_Radius   = 3;
  key_g.OnUpPtr         = 0;
  key_g.OnDownPtr       = 0;
  key_g.OnClickPtr      = key_gOnClick;
  key_g.OnPressPtr      = 0;

  key_h.OwnerScreen     = &PinCode;
  key_h.Order           = 19;
  key_h.Left            = 159;
  key_h.Top             = 132;
  key_h.Width           = 30;
  key_h.Height          = 30;
  key_h.Pen_Width       = 1;
  key_h.Pen_Color       = 0x0000;
  key_h.Visible         = 1;
  key_h.Active          = 1;
  key_h.Transparent     = 1;
  key_h.Caption         = key_h_Caption;
  key_h.TextAlign       = _taCenter;
  key_h.FontName        = Tahoma11x13_Regular;
  key_h.PressColEnabled = 1;
  key_h.Font_Color      = 0x0000;
  key_h.Gradient        = 1;
  key_h.Gradient_Orientation    = 0;
  key_h.Gradient_Start_Color    = 0xFFFF;
  key_h.Gradient_End_Color      = 0xC618;
  key_h.Color           = 0xC618;
  key_h.Press_Color     = 0x8410;
  key_h.Corner_Radius   = 3;
  key_h.OnUpPtr         = 0;
  key_h.OnDownPtr       = 0;
  key_h.OnClickPtr      = key_hOnClick;
  key_h.OnPressPtr      = 0;

  key_j.OwnerScreen     = &PinCode;
  key_j.Order           = 20;
  key_j.Left            = 189;
  key_j.Top             = 132;
  key_j.Width           = 30;
  key_j.Height          = 30;
  key_j.Pen_Width       = 1;
  key_j.Pen_Color       = 0x0000;
  key_j.Visible         = 1;
  key_j.Active          = 1;
  key_j.Transparent     = 1;
  key_j.Caption         = key_j_Caption;
  key_j.TextAlign       = _taCenter;
  key_j.FontName        = Tahoma11x13_Regular;
  key_j.PressColEnabled = 1;
  key_j.Font_Color      = 0x0000;
  key_j.Gradient        = 1;
  key_j.Gradient_Orientation    = 0;
  key_j.Gradient_Start_Color    = 0xFFFF;
  key_j.Gradient_End_Color      = 0xC618;
  key_j.Color           = 0xC618;
  key_j.Press_Color     = 0x8410;
  key_j.Corner_Radius   = 3;
  key_j.OnUpPtr         = 0;
  key_j.OnDownPtr       = 0;
  key_j.OnClickPtr      = key_jOnClick;
  key_j.OnPressPtr      = 0;

  key_k.OwnerScreen     = &PinCode;
  key_k.Order           = 21;
  key_k.Left            = 219;
  key_k.Top             = 132;
  key_k.Width           = 30;
  key_k.Height          = 30;
  key_k.Pen_Width       = 1;
  key_k.Pen_Color       = 0x0000;
  key_k.Visible         = 1;
  key_k.Active          = 1;
  key_k.Transparent     = 1;
  key_k.Caption         = key_k_Caption;
  key_k.TextAlign       = _taCenter;
  key_k.FontName        = Tahoma11x13_Regular;
  key_k.PressColEnabled = 1;
  key_k.Font_Color      = 0x0000;
  key_k.Gradient        = 1;
  key_k.Gradient_Orientation    = 0;
  key_k.Gradient_Start_Color    = 0xFFFF;
  key_k.Gradient_End_Color      = 0xC618;
  key_k.Color           = 0xC618;
  key_k.Press_Color     = 0x8410;
  key_k.Corner_Radius   = 3;
  key_k.OnUpPtr         = 0;
  key_k.OnDownPtr       = 0;
  key_k.OnClickPtr      = key_kOnClick;
  key_k.OnPressPtr      = 0;

  key_l.OwnerScreen     = &PinCode;
  key_l.Order           = 22;
  key_l.Left            = 249;
  key_l.Top             = 132;
  key_l.Width           = 30;
  key_l.Height          = 30;
  key_l.Pen_Width       = 1;
  key_l.Pen_Color       = 0x0000;
  key_l.Visible         = 1;
  key_l.Active          = 1;
  key_l.Transparent     = 1;
  key_l.Caption         = key_l_Caption;
  key_l.TextAlign       = _taCenter;
  key_l.FontName        = Tahoma11x13_Regular;
  key_l.PressColEnabled = 1;
  key_l.Font_Color      = 0x0000;
  key_l.Gradient        = 1;
  key_l.Gradient_Orientation    = 0;
  key_l.Gradient_Start_Color    = 0xFFFF;
  key_l.Gradient_End_Color      = 0xC618;
  key_l.Color           = 0xC618;
  key_l.Press_Color     = 0x8410;
  key_l.Corner_Radius   = 3;
  key_l.OnUpPtr         = 0;
  key_l.OnDownPtr       = 0;
  key_l.OnClickPtr      = key_lOnClick;
  key_l.OnPressPtr      = 0;

  key_m.OwnerScreen     = &PinCode;
  key_m.Order           = 23;
  key_m.Left            = 279;
  key_m.Top             = 132;
  key_m.Width           = 30;
  key_m.Height          = 30;
  key_m.Pen_Width       = 1;
  key_m.Pen_Color       = 0x0000;
  key_m.Visible         = 1;
  key_m.Active          = 1;
  key_m.Transparent     = 1;
  key_m.Caption         = key_m_Caption;
  key_m.TextAlign       = _taCenter;
  key_m.FontName        = Tahoma11x13_Regular;
  key_m.PressColEnabled = 1;
  key_m.Font_Color      = 0x0000;
  key_m.Gradient        = 1;
  key_m.Gradient_Orientation    = 0;
  key_m.Gradient_Start_Color    = 0xFFFF;
  key_m.Gradient_End_Color      = 0xC618;
  key_m.Color           = 0xC618;
  key_m.Press_Color     = 0x8410;
  key_m.Corner_Radius   = 3;
  key_m.OnUpPtr         = 0;
  key_m.OnDownPtr       = 0;
  key_m.OnClickPtr      = key_mOnClick;
  key_m.OnPressPtr      = 0;

  key_1.OwnerScreen     = &PinCode;
  key_1.Order           = 24;
  key_1.Left            = 9;
  key_1.Top             = 72;
  key_1.Width           = 30;
  key_1.Height          = 30;
  key_1.Pen_Width       = 1;
  key_1.Pen_Color       = 0x0000;
  key_1.Visible         = 1;
  key_1.Active          = 1;
  key_1.Transparent     = 1;
  key_1.Caption         = key_1_Caption;
  key_1.TextAlign       = _taCenter;
  key_1.FontName        = Tahoma11x13_Regular;
  key_1.PressColEnabled = 1;
  key_1.Font_Color      = 0x0000;
  key_1.Gradient        = 1;
  key_1.Gradient_Orientation    = 0;
  key_1.Gradient_Start_Color    = 0xFFFF;
  key_1.Gradient_End_Color      = 0xC618;
  key_1.Color           = 0xC618;
  key_1.Press_Color     = 0x8410;
  key_1.Corner_Radius   = 3;
  key_1.OnUpPtr         = 0;
  key_1.OnDownPtr       = 0;
  key_1.OnClickPtr      = key_1OnClick;
  key_1.OnPressPtr      = 0;

  key_2.OwnerScreen     = &PinCode;
  key_2.Order           = 25;
  key_2.Left            = 39;
  key_2.Top             = 72;
  key_2.Width           = 30;
  key_2.Height          = 30;
  key_2.Pen_Width       = 1;
  key_2.Pen_Color       = 0x0000;
  key_2.Visible         = 1;
  key_2.Active          = 1;
  key_2.Transparent     = 1;
  key_2.Caption         = key_2_Caption;
  key_2.TextAlign       = _taCenter;
  key_2.FontName        = Tahoma11x13_Regular;
  key_2.PressColEnabled = 1;
  key_2.Font_Color      = 0x0000;
  key_2.Gradient        = 1;
  key_2.Gradient_Orientation    = 0;
  key_2.Gradient_Start_Color    = 0xFFFF;
  key_2.Gradient_End_Color      = 0xC618;
  key_2.Color           = 0xC618;
  key_2.Press_Color     = 0x8410;
  key_2.Corner_Radius   = 3;
  key_2.OnUpPtr         = 0;
  key_2.OnDownPtr       = 0;
  key_2.OnClickPtr      = key_2OnClick;
  key_2.OnPressPtr      = 0;

  key_3.OwnerScreen     = &PinCode;
  key_3.Order           = 26;
  key_3.Left            = 69;
  key_3.Top             = 72;
  key_3.Width           = 30;
  key_3.Height          = 30;
  key_3.Pen_Width       = 1;
  key_3.Pen_Color       = 0x0000;
  key_3.Visible         = 1;
  key_3.Active          = 1;
  key_3.Transparent     = 1;
  key_3.Caption         = key_3_Caption;
  key_3.TextAlign       = _taCenter;
  key_3.FontName        = Tahoma11x13_Regular;
  key_3.PressColEnabled = 1;
  key_3.Font_Color      = 0x0000;
  key_3.Gradient        = 1;
  key_3.Gradient_Orientation    = 0;
  key_3.Gradient_Start_Color    = 0xFFFF;
  key_3.Gradient_End_Color      = 0xC618;
  key_3.Color           = 0xC618;
  key_3.Press_Color     = 0x8410;
  key_3.Corner_Radius   = 3;
  key_3.OnUpPtr         = 0;
  key_3.OnDownPtr       = 0;
  key_3.OnClickPtr      = key_3OnClick;
  key_3.OnPressPtr      = 0;

  key_4.OwnerScreen     = &PinCode;
  key_4.Order           = 27;
  key_4.Left            = 99;
  key_4.Top             = 72;
  key_4.Width           = 30;
  key_4.Height          = 30;
  key_4.Pen_Width       = 1;
  key_4.Pen_Color       = 0x0000;
  key_4.Visible         = 1;
  key_4.Active          = 1;
  key_4.Transparent     = 1;
  key_4.Caption         = key_4_Caption;
  key_4.TextAlign       = _taCenter;
  key_4.FontName        = Tahoma11x13_Regular;
  key_4.PressColEnabled = 1;
  key_4.Font_Color      = 0x0000;
  key_4.Gradient        = 1;
  key_4.Gradient_Orientation    = 0;
  key_4.Gradient_Start_Color    = 0xFFFF;
  key_4.Gradient_End_Color      = 0xC618;
  key_4.Color           = 0xC618;
  key_4.Press_Color     = 0x8410;
  key_4.Corner_Radius   = 3;
  key_4.OnUpPtr         = 0;
  key_4.OnDownPtr       = 0;
  key_4.OnClickPtr      = key_4OnClick;
  key_4.OnPressPtr      = 0;

  key_5.OwnerScreen     = &PinCode;
  key_5.Order           = 28;
  key_5.Left            = 129;
  key_5.Top             = 72;
  key_5.Width           = 30;
  key_5.Height          = 30;
  key_5.Pen_Width       = 1;
  key_5.Pen_Color       = 0x0000;
  key_5.Visible         = 1;
  key_5.Active          = 1;
  key_5.Transparent     = 1;
  key_5.Caption         = key_5_Caption;
  key_5.TextAlign       = _taCenter;
  key_5.FontName        = Tahoma11x13_Regular;
  key_5.PressColEnabled = 1;
  key_5.Font_Color      = 0x0000;
  key_5.Gradient        = 1;
  key_5.Gradient_Orientation    = 0;
  key_5.Gradient_Start_Color    = 0xFFFF;
  key_5.Gradient_End_Color      = 0xC618;
  key_5.Color           = 0xC618;
  key_5.Press_Color     = 0x8410;
  key_5.Corner_Radius   = 3;
  key_5.OnUpPtr         = 0;
  key_5.OnDownPtr       = 0;
  key_5.OnClickPtr      = key_5OnClick;
  key_5.OnPressPtr      = 0;

  key_6.OwnerScreen     = &PinCode;
  key_6.Order           = 29;
  key_6.Left            = 159;
  key_6.Top             = 72;
  key_6.Width           = 30;
  key_6.Height          = 30;
  key_6.Pen_Width       = 1;
  key_6.Pen_Color       = 0x0000;
  key_6.Visible         = 1;
  key_6.Active          = 1;
  key_6.Transparent     = 1;
  key_6.Caption         = key_6_Caption;
  key_6.TextAlign       = _taCenter;
  key_6.FontName        = Tahoma11x13_Regular;
  key_6.PressColEnabled = 1;
  key_6.Font_Color      = 0x0000;
  key_6.Gradient        = 1;
  key_6.Gradient_Orientation    = 0;
  key_6.Gradient_Start_Color    = 0xFFFF;
  key_6.Gradient_End_Color      = 0xC618;
  key_6.Color           = 0xC618;
  key_6.Press_Color     = 0x8410;
  key_6.Corner_Radius   = 3;
  key_6.OnUpPtr         = 0;
  key_6.OnDownPtr       = 0;
  key_6.OnClickPtr      = key_6OnClick;
  key_6.OnPressPtr      = 0;

  key_7.OwnerScreen     = &PinCode;
  key_7.Order           = 30;
  key_7.Left            = 189;
  key_7.Top             = 72;
  key_7.Width           = 30;
  key_7.Height          = 30;
  key_7.Pen_Width       = 1;
  key_7.Pen_Color       = 0x0000;
  key_7.Visible         = 1;
  key_7.Active          = 1;
  key_7.Transparent     = 1;
  key_7.Caption         = key_7_Caption;
  key_7.TextAlign       = _taCenter;
  key_7.FontName        = Tahoma11x13_Regular;
  key_7.PressColEnabled = 1;
  key_7.Font_Color      = 0x0000;
  key_7.Gradient        = 1;
  key_7.Gradient_Orientation    = 0;
  key_7.Gradient_Start_Color    = 0xFFFF;
  key_7.Gradient_End_Color      = 0xC618;
  key_7.Color           = 0xC618;
  key_7.Press_Color     = 0x8410;
  key_7.Corner_Radius   = 3;
  key_7.OnUpPtr         = 0;
  key_7.OnDownPtr       = 0;
  key_7.OnClickPtr      = key_7OnClick;
  key_7.OnPressPtr      = 0;

  key_8.OwnerScreen     = &PinCode;
  key_8.Order           = 31;
  key_8.Left            = 219;
  key_8.Top             = 72;
  key_8.Width           = 30;
  key_8.Height          = 30;
  key_8.Pen_Width       = 1;
  key_8.Pen_Color       = 0x0000;
  key_8.Visible         = 1;
  key_8.Active          = 1;
  key_8.Transparent     = 1;
  key_8.Caption         = key_8_Caption;
  key_8.TextAlign       = _taCenter;
  key_8.FontName        = Tahoma11x13_Regular;
  key_8.PressColEnabled = 1;
  key_8.Font_Color      = 0x0000;
  key_8.Gradient        = 1;
  key_8.Gradient_Orientation    = 0;
  key_8.Gradient_Start_Color    = 0xFFFF;
  key_8.Gradient_End_Color      = 0xC618;
  key_8.Color           = 0xC618;
  key_8.Press_Color     = 0x8410;
  key_8.Corner_Radius   = 3;
  key_8.OnUpPtr         = 0;
  key_8.OnDownPtr       = 0;
  key_8.OnClickPtr      = key_8OnClick;
  key_8.OnPressPtr      = 0;

  key_9.OwnerScreen     = &PinCode;
  key_9.Order           = 32;
  key_9.Left            = 249;
  key_9.Top             = 72;
  key_9.Width           = 30;
  key_9.Height          = 30;
  key_9.Pen_Width       = 1;
  key_9.Pen_Color       = 0x0000;
  key_9.Visible         = 1;
  key_9.Active          = 1;
  key_9.Transparent     = 1;
  key_9.Caption         = key_9_Caption;
  key_9.TextAlign       = _taCenter;
  key_9.FontName        = Tahoma11x13_Regular;
  key_9.PressColEnabled = 1;
  key_9.Font_Color      = 0x0000;
  key_9.Gradient        = 1;
  key_9.Gradient_Orientation    = 0;
  key_9.Gradient_Start_Color    = 0xFFFF;
  key_9.Gradient_End_Color      = 0xC618;
  key_9.Color           = 0xC618;
  key_9.Press_Color     = 0x8410;
  key_9.Corner_Radius   = 3;
  key_9.OnUpPtr         = 0;
  key_9.OnDownPtr       = 0;
  key_9.OnClickPtr      = key_9OnClick;
  key_9.OnPressPtr      = 0;

  key_0.OwnerScreen     = &PinCode;
  key_0.Order           = 33;
  key_0.Left            = 279;
  key_0.Top             = 72;
  key_0.Width           = 30;
  key_0.Height          = 30;
  key_0.Pen_Width       = 1;
  key_0.Pen_Color       = 0x0000;
  key_0.Visible         = 1;
  key_0.Active          = 1;
  key_0.Transparent     = 1;
  key_0.Caption         = key_0_Caption;
  key_0.TextAlign       = _taCenter;
  key_0.FontName        = Tahoma11x13_Regular;
  key_0.PressColEnabled = 1;
  key_0.Font_Color      = 0x0000;
  key_0.Gradient        = 1;
  key_0.Gradient_Orientation    = 0;
  key_0.Gradient_Start_Color    = 0xFFFF;
  key_0.Gradient_End_Color      = 0xC618;
  key_0.Color           = 0xC618;
  key_0.Press_Color     = 0x8410;
  key_0.Corner_Radius   = 3;
  key_0.OnUpPtr         = 0;
  key_0.OnDownPtr       = 0;
  key_0.OnClickPtr      = key_0OnClick;
  key_0.OnPressPtr      = 0;

  key_w.OwnerScreen     = &PinCode;
  key_w.Order           = 34;
  key_w.Left            = 69;
  key_w.Top             = 162;
  key_w.Width           = 30;
  key_w.Height          = 30;
  key_w.Pen_Width       = 1;
  key_w.Pen_Color       = 0x0000;
  key_w.Visible         = 1;
  key_w.Active          = 1;
  key_w.Transparent     = 1;
  key_w.Caption         = key_w_Caption;
  key_w.TextAlign       = _taCenter;
  key_w.FontName        = Tahoma11x13_Regular;
  key_w.PressColEnabled = 1;
  key_w.Font_Color      = 0x0000;
  key_w.Gradient        = 1;
  key_w.Gradient_Orientation    = 0;
  key_w.Gradient_Start_Color    = 0xFFFF;
  key_w.Gradient_End_Color      = 0xC618;
  key_w.Color           = 0xC618;
  key_w.Press_Color     = 0x8410;
  key_w.Corner_Radius   = 3;
  key_w.OnUpPtr         = 0;
  key_w.OnDownPtr       = 0;
  key_w.OnClickPtr      = key_wOnClick;
  key_w.OnPressPtr      = 0;

  key_x.OwnerScreen     = &PinCode;
  key_x.Order           = 35;
  key_x.Left            = 99;
  key_x.Top             = 162;
  key_x.Width           = 30;
  key_x.Height          = 30;
  key_x.Pen_Width       = 1;
  key_x.Pen_Color       = 0x0000;
  key_x.Visible         = 1;
  key_x.Active          = 1;
  key_x.Transparent     = 1;
  key_x.Caption         = key_x_Caption;
  key_x.TextAlign       = _taCenter;
  key_x.FontName        = Tahoma11x13_Regular;
  key_x.PressColEnabled = 1;
  key_x.Font_Color      = 0x0000;
  key_x.Gradient        = 1;
  key_x.Gradient_Orientation    = 0;
  key_x.Gradient_Start_Color    = 0xFFFF;
  key_x.Gradient_End_Color      = 0xC618;
  key_x.Color           = 0xC618;
  key_x.Press_Color     = 0x8410;
  key_x.Corner_Radius   = 3;
  key_x.OnUpPtr         = 0;
  key_x.OnDownPtr       = 0;
  key_x.OnClickPtr      = key_xOnClick;
  key_x.OnPressPtr      = 0;

  key_c.OwnerScreen     = &PinCode;
  key_c.Order           = 36;
  key_c.Left            = 129;
  key_c.Top             = 162;
  key_c.Width           = 30;
  key_c.Height          = 30;
  key_c.Pen_Width       = 1;
  key_c.Pen_Color       = 0x0000;
  key_c.Visible         = 1;
  key_c.Active          = 1;
  key_c.Transparent     = 1;
  key_c.Caption         = key_c_Caption;
  key_c.TextAlign       = _taCenter;
  key_c.FontName        = Tahoma11x13_Regular;
  key_c.PressColEnabled = 1;
  key_c.Font_Color      = 0x0000;
  key_c.Gradient        = 1;
  key_c.Gradient_Orientation    = 0;
  key_c.Gradient_Start_Color    = 0xFFFF;
  key_c.Gradient_End_Color      = 0xC618;
  key_c.Color           = 0xC618;
  key_c.Press_Color     = 0x8410;
  key_c.Corner_Radius   = 3;
  key_c.OnUpPtr         = 0;
  key_c.OnDownPtr       = 0;
  key_c.OnClickPtr      = key_cOnClick;
  key_c.OnPressPtr      = 0;

  key_v.OwnerScreen     = &PinCode;
  key_v.Order           = 37;
  key_v.Left            = 159;
  key_v.Top             = 162;
  key_v.Width           = 30;
  key_v.Height          = 30;
  key_v.Pen_Width       = 1;
  key_v.Pen_Color       = 0x0000;
  key_v.Visible         = 1;
  key_v.Active          = 1;
  key_v.Transparent     = 1;
  key_v.Caption         = key_v_Caption;
  key_v.TextAlign       = _taCenter;
  key_v.FontName        = Tahoma11x13_Regular;
  key_v.PressColEnabled = 1;
  key_v.Font_Color      = 0x0000;
  key_v.Gradient        = 1;
  key_v.Gradient_Orientation    = 0;
  key_v.Gradient_Start_Color    = 0xFFFF;
  key_v.Gradient_End_Color      = 0xC618;
  key_v.Color           = 0xC618;
  key_v.Press_Color     = 0x8410;
  key_v.Corner_Radius   = 3;
  key_v.OnUpPtr         = 0;
  key_v.OnDownPtr       = 0;
  key_v.OnClickPtr      = key_vOnClick;
  key_v.OnPressPtr      = 0;

  key_b.OwnerScreen     = &PinCode;
  key_b.Order           = 38;
  key_b.Left            = 189;
  key_b.Top             = 162;
  key_b.Width           = 30;
  key_b.Height          = 30;
  key_b.Pen_Width       = 1;
  key_b.Pen_Color       = 0x0000;
  key_b.Visible         = 1;
  key_b.Active          = 1;
  key_b.Transparent     = 1;
  key_b.Caption         = key_b_Caption;
  key_b.TextAlign       = _taCenter;
  key_b.FontName        = Tahoma11x13_Regular;
  key_b.PressColEnabled = 1;
  key_b.Font_Color      = 0x0000;
  key_b.Gradient        = 1;
  key_b.Gradient_Orientation    = 0;
  key_b.Gradient_Start_Color    = 0xFFFF;
  key_b.Gradient_End_Color      = 0xC618;
  key_b.Color           = 0xC618;
  key_b.Press_Color     = 0x8410;
  key_b.Corner_Radius   = 3;
  key_b.OnUpPtr         = 0;
  key_b.OnDownPtr       = 0;
  key_b.OnClickPtr      = key_bOnClick;
  key_b.OnPressPtr      = 0;

  key_n.OwnerScreen     = &PinCode;
  key_n.Order           = 39;
  key_n.Left            = 219;
  key_n.Top             = 162;
  key_n.Width           = 30;
  key_n.Height          = 30;
  key_n.Pen_Width       = 1;
  key_n.Pen_Color       = 0x0000;
  key_n.Visible         = 1;
  key_n.Active          = 1;
  key_n.Transparent     = 1;
  key_n.Caption         = key_n_Caption;
  key_n.TextAlign       = _taCenter;
  key_n.FontName        = Tahoma11x13_Regular;
  key_n.PressColEnabled = 1;
  key_n.Font_Color      = 0x0000;
  key_n.Gradient        = 1;
  key_n.Gradient_Orientation    = 0;
  key_n.Gradient_Start_Color    = 0xFFFF;
  key_n.Gradient_End_Color      = 0xC618;
  key_n.Color           = 0xC618;
  key_n.Press_Color     = 0x8410;
  key_n.Corner_Radius   = 3;
  key_n.OnUpPtr         = 0;
  key_n.OnDownPtr       = 0;
  key_n.OnClickPtr      = key_nOnClick;
  key_n.OnPressPtr      = 0;

  key_shift.OwnerScreen     = &PinCode;
  key_shift.Order           = 40;
  key_shift.Left            = 10;
  key_shift.Top             = 162;
  key_shift.Width           = 60;
  key_shift.Height          = 30;
  key_shift.Pen_Width       = 1;
  key_shift.Pen_Color       = 0x0000;
  key_shift.Visible         = 1;
  key_shift.Active          = 1;
  key_shift.Transparent     = 1;
  key_shift.Caption         = key_shift_Caption;
  key_shift.TextAlign       = _taCenter;
  key_shift.FontName        = Tahoma11x13_Regular;
  key_shift.PressColEnabled = 1;
  key_shift.Font_Color      = 0x0000;
  key_shift.Gradient        = 1;
  key_shift.Gradient_Orientation    = 0;
  key_shift.Gradient_Start_Color    = 0xFFFF;
  key_shift.Gradient_End_Color      = 0xC618;
  key_shift.Color           = 0xC618;
  key_shift.Press_Color     = 0x8410;
  key_shift.Corner_Radius   = 3;
  key_shift.OnUpPtr         = 0;
  key_shift.OnDownPtr       = 0;
  key_shift.OnClickPtr      = key_shiftOnClick;
  key_shift.OnPressPtr      = 0;

  key_back.OwnerScreen     = &PinCode;
  key_back.Order           = 41;
  key_back.Left            = 250;
  key_back.Top             = 162;
  key_back.Width           = 60;
  key_back.Height          = 30;
  key_back.Pen_Width       = 1;
  key_back.Pen_Color       = 0x0000;
  key_back.Visible         = 1;
  key_back.Active          = 1;
  key_back.Transparent     = 1;
  key_back.Caption         = key_back_Caption;
  key_back.TextAlign       = _taCenter;
  key_back.FontName        = Tahoma11x13_Regular;
  key_back.PressColEnabled = 1;
  key_back.Font_Color      = 0x0000;
  key_back.Gradient        = 1;
  key_back.Gradient_Orientation    = 0;
  key_back.Gradient_Start_Color    = 0xFFFF;
  key_back.Gradient_End_Color      = 0xC618;
  key_back.Color           = 0xC618;
  key_back.Press_Color     = 0x8410;
  key_back.Corner_Radius   = 3;
  key_back.OnUpPtr         = 0;
  key_back.OnDownPtr       = 0;
  key_back.OnClickPtr      = key_backOnClick;
  key_back.OnPressPtr      = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) { // static
  if ( (Left<= X) && (Left+ Width - 1 >= X) &&
       (Top <= Y)  && (Top + Height - 1 >= Y) )
    return 1;
  else
    return 0;
}


#define GetButton(index)              CurrentScreen->Buttons[index]
#define GetCButton(index)             CurrentScreen->CButtons[index]
#define GetRoundButton(index)         CurrentScreen->Buttons_Round[index]
#define GetLabel(index)               CurrentScreen->Labels[index]
#define GetCLabel(index)              CurrentScreen->CLabels[index]
#define GetBox(index)                 CurrentScreen->Boxes[index]
#define GetCBox(index)                CurrentScreen->CBoxes[index]
#define GetLine(index)                CurrentScreen->Lines[index]


void DrawButton(TButton *Abutton) {
  if (Abutton->Visible == 1) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(Abutton->Transparent, Abutton->Press_Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color);
    }
    TFT_Set_Pen(Abutton->Pen_Color, Abutton->Pen_Width);
    TFT_Rectangle(Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1);
    TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text_Return_Pos(Abutton->Caption, Abutton->Left, Abutton->Top);
    if (Abutton->TextAlign == _taLeft)
      TFT_Write_Text(Abutton->Caption, Abutton->Left + 4, (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
    else if (Abutton->TextAlign == _taCenter)
      TFT_Write_Text(Abutton->Caption, (Abutton->Left + (Abutton->Width - caption_length) / 2), (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
    else if (Abutton->TextAlign == _taRight)
      TFT_Write_Text(Abutton->Caption, Abutton->Left + (Abutton->Width - caption_length - 4), (Abutton->Top + (Abutton->Height - caption_height) / 2));
  }
}

void DrawCButton(TCButton *Abutton) {
  if (Abutton->Visible == 1) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(Abutton->Transparent, Abutton->Press_Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color);
    }
    TFT_Set_Pen(Abutton->Pen_Color, Abutton->Pen_Width);
    TFT_Rectangle(Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1);
    TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text_Return_Pos(Abutton->Caption, Abutton->Left, Abutton->Top);
    if (Abutton->TextAlign == _taLeft)
      TFT_Write_Text(Abutton->Caption, Abutton->Left + 4, (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
    else if (Abutton->TextAlign == _taCenter)
      TFT_Write_Text(Abutton->Caption, (Abutton->Left + (Abutton->Width - caption_length) / 2), (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
    else if (Abutton->TextAlign == _taRight)
      TFT_Write_Text(Abutton->Caption, Abutton->Left + (Abutton->Width - caption_length - 4), (Abutton->Top + (Abutton->Height - caption_height) / 2));
  }
}

void DrawRoundButton(TButton_Round *Around_button) {
    if (Around_button->Visible == 1) {
      if (object_pressed == 1) {
        object_pressed = 0;
        TFT_Set_Brush(Around_button->Transparent, Around_button->Press_Color, Around_button->Gradient, Around_button->Gradient_Orientation,
                      Around_button->Gradient_End_Color, Around_button->Gradient_Start_Color);
      }
      else {
        TFT_Set_Brush(Around_button->Transparent, Around_button->Color, Around_button->Gradient, Around_button->Gradient_Orientation,
                      Around_button->Gradient_Start_Color, Around_button->Gradient_End_Color);
      }
      TFT_Set_Pen(Around_button->Pen_Color, Around_button->Pen_Width);
      TFT_Rectangle_Round_Edges(Around_button->Left + 1, Around_button->Top + 1,
        Around_button->Left + Around_button->Width - 2,
        Around_button->Top + Around_button->Height - 2, Around_button->Corner_Radius);
      TFT_Set_Font(Around_button->FontName, Around_button->Font_Color, FO_HORIZONTAL);
      TFT_Write_Text_Return_Pos(Around_button->Caption, Around_button->Left, Around_button->Top);
      if (Around_button->TextAlign == _taLeft)
        TFT_Write_Text(Around_button->Caption, Around_button->Left + 4, (Around_button->Top + ((Around_button->Height - caption_height) / 2)));
      else if (Around_button->TextAlign == _taCenter)
        TFT_Write_Text(Around_button->Caption, (Around_button->Left + (Around_button->Width - caption_length) / 2), (Around_button->Top + ((Around_button->Height - caption_height) / 2)));
      else if (Around_button->TextAlign == _taRight)
        TFT_Write_Text(Around_button->Caption, Around_button->Left + (Around_button->Width - caption_length - 4), (Around_button->Top + (Around_button->Height - caption_height) / 2));
    }
}

void DrawLabel(TLabel *ALabel) {
  if (ALabel->Visible == 1) {
    TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
  }
}

void DrawCLabel(TCLabel *ALabel) {
  if (ALabel->Visible == 1) {
    TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
  }
}

void DrawBox(TBox *ABox) {
  if (ABox->Visible == 1) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(ABox->Transparent, ABox->Press_Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_End_Color, ABox->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(ABox->Transparent, ABox->Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_Start_Color, ABox->Gradient_End_Color);
    }
    TFT_Set_Pen(ABox->Pen_Color, ABox->Pen_Width);
    TFT_Rectangle(ABox->Left, ABox->Top, ABox->Left + ABox->Width - 1, ABox->Top + ABox->Height - 1);
  }
}

void DrawCBox(TCBox *ABox) {
  if (ABox->Visible == 1) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(ABox->Transparent, ABox->Press_Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_End_Color, ABox->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(ABox->Transparent, ABox->Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_Start_Color, ABox->Gradient_End_Color);
    }
    TFT_Set_Pen(ABox->Pen_Color, ABox->Pen_Width);
    TFT_Rectangle(ABox->Left, ABox->Top, ABox->Left + ABox->Width - 1, ABox->Top + ABox->Height - 1);
  }
}

void DrawLine(TLine *Aline) {
  if (Aline->Visible == 1) {
    TFT_Set_Pen(Aline->Color, Aline->Pen_Width);
    TFT_Line(Aline->First_Point_X, Aline->First_Point_Y, Aline->Second_Point_X, Aline->Second_Point_Y);
  }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
  unsigned short button_idx;
  TButton *local_button;
  unsigned short cbutton_idx;
  TCButton *local_cbutton;
  unsigned short round_button_idx;
  TButton_Round *local_round_button;
  unsigned short label_idx;
  TLabel *local_label;
  unsigned short clabel_idx;
  TCLabel *local_clabel;
  unsigned short box_idx;
  TBox *local_box;
  unsigned short cbox_idx;
  TCBox *local_cbox;
  unsigned short line_idx;
  TLine *local_line;
  char save_bled, save_bled_direction;

  object_pressed = 0;
  order = 0;
  button_idx = 0;
  cbutton_idx = 0;
  round_button_idx = 0;
  label_idx = 0;
  clabel_idx = 0;
  box_idx = 0;
  cbox_idx = 0;
  line_idx = 0;
  CurrentScreen = aScreen;

  if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
    save_bled = TFT_BLED;
    save_bled_direction = TFT_BLED_Direction;
    TFT_BLED_Direction = 0;
    TFT_BLED           = 0;
    TFT_Set_Active(Set_Index, Write_Command, Write_Data);
    TFT_Init(CurrentScreen->Width, CurrentScreen->Height);
    TP_TFT_Init(CurrentScreen->Width, CurrentScreen->Height, 13, 12);                                  // Initialize touch panel
    TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);                              // Set touch panel ADC threshold
    TFT_Fill_Screen(CurrentScreen->Color);
    display_width = CurrentScreen->Width;
    display_height = CurrentScreen->Height;
    TFT_BLED           = save_bled;
    TFT_BLED_Direction = save_bled_direction;
  }
  else
    TFT_Fill_Screen(CurrentScreen->Color);


  while (order < CurrentScreen->ObjectsCount) {
    if (button_idx < CurrentScreen->ButtonsCount) {
      local_button = GetButton(button_idx);
      if (order == local_button->Order) {
        button_idx++;
        order++;
        DrawButton(local_button);
      }
    }

    if (cbutton_idx < CurrentScreen->CButtonsCount) {
      local_cbutton = GetCButton(cbutton_idx);
      if (order == local_cbutton->Order) {
        cbutton_idx++;
        order++;
        DrawCButton(local_cbutton);
      }
    }

    if (round_button_idx < CurrentScreen->Buttons_RoundCount) {
      local_round_button = GetRoundButton(round_button_idx);
      if (order == local_round_button->Order) {
        order++;
        round_button_idx++;
        DrawRoundButton(local_round_button);
      }
    }

    if (label_idx < CurrentScreen->LabelsCount) {
      local_label = GetLabel(label_idx);
      if (order == local_label->Order) {
        label_idx++;
        order++;
        DrawLabel(local_label);
      }
    }

    if (clabel_idx < CurrentScreen->CLabelsCount) {
      local_clabel = GetCLabel(clabel_idx);
      if (order == local_clabel->Order) {
        clabel_idx++;
        order++;
        DrawCLabel(local_clabel);
      }
    }

    if (box_idx < CurrentScreen->BoxesCount) {
      local_box = GetBox(box_idx);
      if (order == local_box->Order) {
        box_idx++;
        order++;
        DrawBox(local_box);
      }
    }

    if (cbox_idx < CurrentScreen->CBoxesCount) {
      local_cbox = GetCBox(cbox_idx);
      if (order == local_cbox->Order) {
        cbox_idx++;
        order++;
        DrawCBox(local_cbox);
      }
    }

    if (line_idx  < CurrentScreen->LinesCount) {
      local_line = GetLine(line_idx);
      if (order == local_line->Order) {
        line_idx++;
        order++;
        DrawLine(local_line);
      }
    }

  }
}

void Get_Object(unsigned int X, unsigned int Y) {
  button_order        = -1;
  cbutton_order       = -1;
  round_button_order  = -1;
  label_order         = -1;
  clabel_order        = -1;
  box_order           = -1;
  cbox_order          = -1;
  //  Buttons
  for ( _object_count = 0 ; _object_count < CurrentScreen->ButtonsCount ; _object_count++ ) {
    local_button = GetButton(_object_count);
    if (local_button->Active == 1) {
      if (IsInsideObject(X, Y, local_button->Left, local_button->Top,
                         local_button->Width, local_button->Height) == 1) {
        button_order = local_button->Order;
        exec_button = local_button;
      }
    }
  }

  //  CButtons
  for ( _object_count = 0 ; _object_count < CurrentScreen->CButtonsCount ; _object_count++ ) {
    local_cbutton = GetCButton(_object_count);
    if (local_cbutton->Active == 1) {
      if (IsInsideObject(X, Y, local_cbutton->Left, local_cbutton->Top,
                         local_cbutton->Width, local_cbutton->Height) == 1) {
        cbutton_order = local_cbutton->Order;
        exec_cbutton = local_cbutton;
      }
    }
  }

  //  Buttons with Round Edges
  for ( _object_count = 0 ; _object_count < CurrentScreen->Buttons_RoundCount ; _object_count++ ) {
    local_round_button = GetRoundButton(_object_count);
    if (local_round_button->Active == 1) {
      if (IsInsideObject(X, Y, local_round_button->Left, local_round_button->Top,
                         local_round_button->Width, local_round_button->Height) == 1) {
        round_button_order = local_round_button->Order;
        exec_round_button = local_round_button;
      }
    }
  }

  //  Labels
  for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
    local_label = GetLabel(_object_count);
    if (local_label->Active == 1) {
      if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
                         local_label->Width, local_label->Height) == 1) {
        label_order = local_label->Order;
        exec_label = local_label;
      }
    }
  }

  //  CLabels
  for ( _object_count = 0 ; _object_count < CurrentScreen->CLabelsCount ; _object_count++ ) {
    local_clabel = GetCLabel(_object_count);
    if (local_clabel->Active == 1) {
      if (IsInsideObject(X, Y, local_clabel->Left, local_clabel->Top,
                         local_clabel->Width, local_clabel->Height) == 1) {
        clabel_order = local_clabel->Order;
        exec_clabel = local_clabel;
      }
    }
  }

  //  Boxes
  for ( _object_count = 0 ; _object_count < CurrentScreen->BoxesCount ; _object_count++ ) {
    local_box = GetBox(_object_count);
    if (local_box->Active == 1) {
      if (IsInsideObject(X, Y, local_box->Left, local_box->Top,
                         local_box->Width, local_box->Height) == 1) {
        box_order = local_box->Order;
        exec_box = local_box;
      }
    }
  }

  //  CBoxes
  for ( _object_count = 0 ; _object_count < CurrentScreen->CBoxesCount ; _object_count++ ) {
    local_cbox = GetCBox(_object_count);
    if (local_cbox->Active == 1) {
      if (IsInsideObject(X, Y, local_cbox->Left, local_cbox->Top,
                         local_cbox->Width, local_cbox->Height) == 1) {
        cbox_order = local_cbox->Order;
        exec_cbox = local_cbox;
      }
    }
  }

  _object_count = -1;
  if (button_order > _object_count)
    _object_count = button_order;
  if (cbutton_order > _object_count)
    _object_count = cbutton_order;
  if (round_button_order > _object_count)
    _object_count = round_button_order;
  if (label_order >  _object_count )
    _object_count = label_order;
  if (clabel_order >  _object_count )
    _object_count = clabel_order;
  if (box_order >  _object_count )
    _object_count = box_order;
  if (cbox_order >  _object_count )
    _object_count = cbox_order;
}


static void Process_TP_Press(unsigned int X, unsigned int Y) {
  exec_button         = 0;
  exec_cbutton        = 0;
  exec_round_button   = 0;
  exec_label          = 0;
  exec_clabel         = 0;
  exec_box            = 0;
  exec_cbox           = 0;

  Get_Object(X, Y);


  if (_object_count != -1) {
    if (_object_count == button_order) {
      if (exec_button->Active == 1) {
        if (exec_button->OnPressPtr != 0) {
          exec_button->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == cbutton_order) {
      if (exec_cbutton->Active == 1) {
        if (exec_cbutton->OnPressPtr != 0) {
          exec_cbutton->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == round_button_order) {
      if (exec_round_button->Active == 1) {
        if (exec_round_button->OnPressPtr != 0) {
          exec_round_button->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active == 1) {
        if (exec_label->OnPressPtr != 0) {
          exec_label->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == clabel_order) {
      if (exec_clabel->Active == 1) {
        if (exec_clabel->OnPressPtr != 0) {
          exec_clabel->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == box_order) {
      if (exec_box->Active == 1) {
        if (exec_box->OnPressPtr != 0) {
          exec_box->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == cbox_order) {
      if (exec_cbox->Active == 1) {
        if (exec_cbox->OnPressPtr != 0) {
          exec_cbox->OnPressPtr();
          return;
        }
      }
    }

  }
}

static void Process_TP_Up(unsigned int X, unsigned int Y) {

  switch (PressedObjectType) {
    // Button
    case 0: {
      if (PressedObject != 0) {
        exec_button = (TButton*)PressedObject;
        if ((exec_button->PressColEnabled == 1) && (exec_button->OwnerScreen == CurrentScreen)) {
          DrawButton(exec_button);
        }
        break;
      }
      break;
    }
    // CButton
    case 8: {
      if (PressedObject != 0) {
        exec_cbutton = (TCButton*)PressedObject;
        if ((exec_cbutton->PressColEnabled == 1) && (exec_cbutton->OwnerScreen == CurrentScreen)) {
          DrawCButton(exec_cbutton);
        }
        break;
      }
      break;
    }
    // Round Button
    case 1: {
      if (PressedObject != 0) {
        exec_round_button = (TButton_Round*)PressedObject;
        if ((exec_round_button->PressColEnabled == 1) && (exec_round_button->OwnerScreen == CurrentScreen)) {
          DrawRoundButton(exec_round_button);
        }
        break;
      }
      break;
    }
    // Box
    case 6: {
      if (PressedObject != 0) {
        exec_box = (TBox*)PressedObject;
        if ((exec_box->PressColEnabled == 1) && (exec_box->OwnerScreen == CurrentScreen)) {
          DrawBox(exec_box);
        }
        break;
      }
      break;
    }
    // CBox
    case 14: {
      if (PressedObject != 0) {
        exec_cbox = (TCBox*)PressedObject;
        if ((exec_cbox->PressColEnabled == 1) && (exec_cbox->OwnerScreen == CurrentScreen)) {
          DrawCBox(exec_cbox);
        }
        break;
      }
      break;
    }
  }

  exec_label          = 0;
  exec_clabel          = 0;

  Get_Object(X, Y);


  if (_object_count != -1) {
  // Buttons
    if (_object_count == button_order) {
      if (exec_button->Active == 1) {
        if (exec_button->OnUpPtr != 0)
          exec_button->OnUpPtr();
        if (PressedObject == (TPointer)exec_button)
          if (exec_button->OnClickPtr != 0)
            exec_button->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // CButtons
    if (_object_count == cbutton_order) {
      if (exec_cbutton->Active == 1) {
        if (exec_cbutton->OnUpPtr != 0)
          exec_cbutton->OnUpPtr();
        if (PressedObject == (TPointer)exec_cbutton)
          if (exec_cbutton->OnClickPtr != 0)
            exec_cbutton->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Buttons with Round Edges
    if (_object_count == round_button_order) {
      if (exec_round_button->Active == 1) {
        if (exec_round_button->OnUpPtr != 0)
          exec_round_button->OnUpPtr();
        if (PressedObject == (TPointer)exec_round_button)
          if (exec_round_button->OnClickPtr != 0)
            exec_round_button->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Labels
    if (_object_count == label_order) {
      if (exec_label->Active == 1) {
        if (exec_label->OnUpPtr != 0)
          exec_label->OnUpPtr();
        if (PressedObject == (TPointer)exec_label)
          if (exec_label->OnClickPtr != 0)
            exec_label->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // CLabels
    if (_object_count == clabel_order) {
      if (exec_clabel->Active == 1) {
        if (exec_clabel->OnUpPtr != 0)
          exec_clabel->OnUpPtr();
        if (PressedObject == (TPointer)exec_clabel)
          if (exec_clabel->OnClickPtr != 0)
            exec_clabel->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Boxes
    if (_object_count == box_order) {
      if (exec_box->Active == 1) {
        if (exec_box->OnUpPtr != 0)
          exec_box->OnUpPtr();
        if (PressedObject == (TPointer)exec_box)
          if (exec_box->OnClickPtr != 0)
            exec_box->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // CBoxes
    if (_object_count == cbox_order) {
      if (exec_cbox->Active == 1) {
        if (exec_cbox->OnUpPtr != 0)
          exec_cbox->OnUpPtr();
        if (PressedObject == (TPointer)exec_cbox)
          if (exec_cbox->OnClickPtr != 0)
            exec_cbox->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  }
  PressedObject = 0;
  PressedObjectType = -1;
}

static void Process_TP_Down(unsigned int X, unsigned int Y) {

  object_pressed      = 0;
  exec_button         = 0;
  exec_cbutton        = 0;
  exec_round_button   = 0;
  exec_label          = 0;
  exec_clabel         = 0;
  exec_box            = 0;
  exec_cbox           = 0;

  Get_Object(X, Y);

  if (_object_count != -1) {
    if (_object_count == button_order) {
      if (exec_button->Active == 1) {
        if (exec_button->PressColEnabled == 1) {
          object_pressed = 1;
          DrawButton(exec_button);
        }
        PressedObject = (TPointer)exec_button;
        PressedObjectType = 0;
        if (exec_button->OnDownPtr != 0) {
          exec_button->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == cbutton_order) {
      if (exec_cbutton->Active == 1) {
        if (exec_cbutton->PressColEnabled == 1) {
          object_pressed = 1;
          DrawCButton(exec_cbutton);
        }
        PressedObject = (TPointer)exec_cbutton;
        PressedObjectType = 8;
        if (exec_cbutton->OnDownPtr != 0) {
          exec_cbutton->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == round_button_order) {
      if (exec_round_button->Active == 1) {
        if (exec_round_button->PressColEnabled == 1) {
          object_pressed = 1;
          DrawRoundButton(exec_round_button);
        }
        PressedObject = (TPointer)exec_round_button;
        PressedObjectType = 1;
        if (exec_round_button->OnDownPtr != 0) {
          exec_round_button->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active == 1) {
        PressedObject = (TPointer)exec_label;
        PressedObjectType = 2;
        if (exec_label->OnDownPtr != 0) {
          exec_label->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == clabel_order) {
      if (exec_clabel->Active == 1) {
        PressedObject = (TPointer)exec_clabel;
        PressedObjectType = 10;
        if (exec_clabel->OnDownPtr != 0) {
          exec_clabel->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == box_order) {
      if (exec_box->Active == 1) {
        if (exec_box->PressColEnabled == 1) {
          object_pressed = 1;
          DrawBox(exec_box);
        }
        PressedObject = (TPointer)exec_box;
        PressedObjectType = 6;
        if (exec_box->OnDownPtr != 0) {
          exec_box->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == cbox_order) {
      if (exec_cbox->Active == 1) {
        if (exec_cbox->PressColEnabled == 1) {
          object_pressed = 1;
          DrawCBox(exec_cbox);
        }
        PressedObject = (TPointer)exec_cbox;
        PressedObjectType = 14;
        if (exec_cbox->OnDownPtr != 0) {
          exec_cbox->OnDownPtr();
          return;
        }
      }
    }

  }
}

void Check_TP() {
  if (TP_TFT_Press_Detect()) {
    // After a PRESS is detected read X-Y and convert it to Display dimensions space
    if (TP_TFT_Get_Coordinates(&Xcoord, &Ycoord) == 0) {
      Process_TP_Press(Xcoord, Ycoord);
      if (PenDown == 0) {
        PenDown = 1;
        Process_TP_Down(Xcoord, Ycoord);
      }
    }
  }
  else if (PenDown == 1) {
    PenDown = 0;
    Process_TP_Up(Xcoord, Ycoord);
  }
}

void Init_MCU() {
  PMMODE = 0;
  PMAEN  = 0;
  PMCON  = 0;  // WRSP: Write Strobe Polarity bit
  PMMODEbits.MODE = 2;     // Master 2
  PMMODEbits.WAITB = 0;
  PMMODEbits.WAITM = 1;
  PMMODEbits.WAITE = 0;
  PMMODEbits.MODE16 = 1;   // 16 bit mode
  PMCONbits.CSF = 0;
  PMCONbits.PTRDEN = 1;
  PMCONbits.PTWREN = 1;
  PMCONbits.PMPEN = 1;
  TP_TFT_Rotate_180(0);
  TFT_Set_Active(Set_Index,Write_Command,Write_Data);
}

void Start_TP() {
  Init_MCU();

  InitializeTouchPanel();

  // You can get calibration constants using touch panel calibration example
  TP_TFT_Set_Calibration_Consts(76, 907, 77, 915);    // Set calibration constants

  InitializeObjects();
  display_width = HomeScreen.Width;
  display_height = HomeScreen.Height;
  DrawScreen(&HomeScreen);
}
