#include "test_bt_objects.h"
#include "test_bt_resources.h"

//--------------------- User code ---------------------//

#define PIN_CODE_SIZE   17
#define PI              3.14

typedef struct  Device {
  char adresse[13];
  char name[51];
  char CoD[7];
} TDevice;

char delim[3] = {0x0D, 0x0A, 0x00};
char temp[100];
int connected = 0;
int toogle = 0;
TDevice devList[15];
TScreen * drawPreviousScreen;


const code char pin_code[20]="1234";
extern playing;

union {
      char string[20]; //20: multiple de 4 le plus proche de 17
      unsigned long tabw[5];
} pin_code_ram;

//extern CurrentScreen;
extern sound_file;

void DrawSuccessScreen(char * string);

void addChar (char * str, char chr) {
     int len = strlen(str);
     if (len < PIN_CODE_SIZE) {
       *(str+len) = chr;
       *(str+len+1) = 0;
       DrawCBox(&cache_pin_str);
       DrawLabel(&TextField);
     }
}

void delChar (char * str) {
     int len = strlen(str);
     if (len <= 0) return;
     *(str+len-1) = 0;
     DrawCBox(&cache_pin_str);
     DrawLabel(&TextField);
}

void toUpperCase(char * str) {
     int i = 0;

     for (i=0; i<strlen(str); i++) *(str+i) = toupper(str[i]);
}

void toLowerCase(char * str) {
     int i = 0;

     for (i=0; i<strlen(str); i++) *(str+i) = tolower(str[i]);
}

void ViderBuffer(char * Buffer, int taille_buffer) {
     int i = 0;
     for (i=0; i<taille_buffer; i++) *(Buffer+i) = 0;
}

void ResetParani() {
     latd.f11 = 0;
     Delay_ms(1500);
     latd.f11 = 1;
     connected = 0;
}

int UART1_ReadLine (char * OutLine) {
      UART1_Read_Text(OutLine, delim, 255);
      if (strlen(OutLine) == 0) UART1_Read_Text(OutLine, delim, 255);
      if(strstr(OutLine, "OK")!=0) return 1;
      else if(strstr(OutLine, "ERROR")!=0) return -1;
      else return 0;
}

void UpdateLabel(TLabel * lbl, char * txt) {
     lbl->Font_Color = 0xFFFF;
     DrawLabel(lbl);
     lbl->Font_Color = 0x0000;
     strcpy(lbl->Caption, txt);
     DrawLabel(lbl);
}

void SendCMD (char * cmd) {
     UART1_Write_Text(cmd);
     UART1_Write(0x0D);
}

void DrawErrorScreen(char * title, char * str) {
     strcpy(Label10.caption, str);
     strcpy(Label8.caption, title);
     DrawScreen(&ConErrorScreen);
}

void DrawPinScreen() {
     strcpy(TextField.caption, pin_code);
     DrawScreen(&PinCode);
}

void DrawSuccessScreen(char * string) {
     strcpy(SuccessLabel.caption, string);
     DrawScreen(&ConSuccessScreen);
     Delay_ms(1000);
     DrawScreen(&HomeScreen);
}

void DrawInqScreen() {
     int res = 0;
     char title[40];
     char * idx = temp;
     int index_courant = 0;
     
     TButton * const code Device_Labels[15]=
       {
       &dev1,
       &dev2,
       &dev3,
       &dev4,
       &dev5,
       &dev6,
       &dev7,
       &dev8,
       &dev9,
       &dev10,
       &dev11,
       &dev12,
       &dev13,
       &dev14,
       &dev15
       };
       
     if(connected) {
         drawPreviousScreen = &InqScreen;
         DrawScreen(&DiscoScreen);
     }
     else {
       UpdateLabel(&InqTitle, "Searching ...");

       SendCmd("AT+BTINQ?");

       for (index_courant = 0; index_courant<15; index_courant++){
         Device_Labels[index_courant]->visible = 0;
         ViderBuffer(Device_Labels[index_courant]->caption, 51);
         ViderBuffer(devList[index_courant].adresse, 13);
         ViderBuffer(devList[index_courant].name, 51);
         ViderBuffer(devList[index_courant].CoD, 7);
       }
       index_courant = 0;

       DrawScreen(&InqScreen);

       while (UART1_ReadLine(temp) == 0) {
          idx = temp;
          strncpy(devList[index_courant].adresse, idx, (int)strchr(idx, ',')-(int)idx);
          idx = strchr(idx, ',')+1;
          strncpy(devList[index_courant].name, idx, (int)strchr(idx, ',')-(int)idx);
          idx = strchr(idx, ',')+1;
          strcpy(devList[index_courant].CoD, idx);

          strcpy(Device_Labels[index_courant]->caption, devList[index_courant].name);
          Device_Labels[index_courant]->visible = 1;
          DrawButton(Device_Labels[index_courant]);
          index_courant++;
          sprintf(title, "%d devices found ...",index_courant);
          DrawCBox(&Box1);
          UpdateLabel(&InqTitle, title);
       }

       if (index_courant == 0) {
          sprintf(title, "No device found",index_courant);
          DrawCBox(&Box1);
          UpdateLabel(&InqTitle, title);
       }
       else {
          sprintf(title, "%d devices found",index_courant);
          DrawCBox(&Box1);
          UpdateLabel(&InqTitle, title);
       }
    }
}

void DrawGetInfo() {
     char * idx = temp;
     int res = 0;
     SendCMD("AT+BTINFO?");

     if(connected) {
         drawPreviousScreen = &InfoScreen;
         DrawScreen(&DiscoScreen);
     }
     else {
       res = UART1_ReadLine(temp);
       if (res == 0) {
         strncpy(BtAdresseLbl.caption, idx, (int)strchr(idx, ',')-(int)idx);
         idx = strchr(idx, ',')+1;
         strncpy(DevNameLbl.caption, idx, (int)strchr(idx, ',')-(int)idx);
         idx = strchr(idx, ',')+1;
         strncpy(ModeLbl.caption, idx, (int)strchr(idx, ',')-(int)idx);
         idx = strchr(idx, ',')+1;
         strncpy(StatusLbl.caption, idx, (int)strchr(idx, ',')-(int)idx);
         idx = strchr(idx, ',')+1;
         strncpy(AuthLbl.caption, idx, (int)strchr(idx, ',')-(int)idx);
         idx = strchr(idx, ',')+1;
         strncpy(EncrLbl.caption, idx, (int)strchr(idx, ',')-(int)idx);
         idx = strchr(idx, ',')+1;
         strcpy(FlowLbl.caption, idx);

         res = UART1_ReadLine(temp);
         if (res == -1) {
           strcpy(BtAdresseLbl.caption,"Error");
           strcpy(DevNameLbl.caption,"Error");
           strcpy(ModeLbl.caption,"Error");
           strcpy(StatusLbl.caption,"Error");
           strcpy(AuthLbl.caption,"Error");
           strcpy(EncrLbl.caption,"Error");
           strcpy(FlowLbl.caption,"Error");
         }
       }

       else {
           strcpy(BtAdresseLbl.caption,"Error");
           strcpy(DevNameLbl.caption,"Error");
           strcpy(ModeLbl.caption,"Error");
           strcpy(StatusLbl.caption,"Error");
           strcpy(AuthLbl.caption,"Error");
           strcpy(EncrLbl.caption,"Error");
           strcpy(FlowLbl.caption,"Error");
       }
       DrawScreen(&InfoScreen);
    }
} 
//----------------- End of User code ------------------//

// Event Handlers

void Info_ButtonOnClick() {
     DrawGetInfo();
}

void BackButtonOnClick() {
     DrawScreen(&HomeScreen);
}

void Button1OnClick() {
     char mess[51];
     char cmd[51];
     int cpt = 0;
     
     if(strlen(TextField.caption) != 0){
       sprintf(cmd, "AT+BTKEY=\"%s\"", TextField.caption);
       SendCMD(cmd);
       if (UART1_ReadLine(temp)==1) {
          /*for (cpt=0; cpt<5; cpt++) {
            strcpy(pin_code_ram.string, TextField.caption);
            Flash_Write_Word(&pin_code+cpt, TextField.caption+cpt*4);
          }     */
          DrawSuccessScreen("Pin Code Changed");
       }
       else {
            sprintf(mess,"%s >> %s", cmd, temp);
            DrawErrorScreen("PIN Code Error !", mess);
       }
     }
     else DrawScreen(&HomeScreen);
}

/* Devices buttons */
void dev1OnClick() {
     return;
}


void dev2OnClick() {
     return;
}

void dev3OnClick() {
     return;
}

void dev4OnClick() {
     return;
}

void dev5OnClick() {
     return;
}

void dev6OnClick() {
     return;
}

void dev7OnClick() {
     return;
}

void dev8OnClick() {
     return;
}

void dev9OnClick() {
     return;
}

void dev10OnClick() {
     return;
}

void dev11OnClick() {
     return;
}

void dev12OnClick() {
     return;
}

void dev13OnClick() {
     return;
}

void dev14OnClick() {
     return;
}

void dev15OnClick() {
     return;
}

void DiscoButtonOnClick() {
     ResetParani();
     if (drawPreviousScreen == &InfoScreen) DrawGetInfo();
     else if (drawPreviousScreen == &InqScreen) DrawInqScreen();
     else DrawScreen(drawPreviousScreen);
}

/* Keyboards buttons */
void key_1OnClick() {
     addChar(TextField.caption, key_1.caption[0]);
     return;
}

void key_2OnClick() {
     addChar(TextField.caption, key_2.caption[0]);
     return;
}

void key_3OnClick() {
     addChar(TextField.caption, key_3.caption[0]);
     return;
}

void key_4OnClick() {
     addChar(TextField.caption, key_4.caption[0]);
     return;
}

void key_5OnClick() {
     addChar(TextField.caption, key_5.caption[0]);
     return;
}

void key_6OnClick() {
     addChar(TextField.caption, key_6.caption[0]);
     return;
}

void key_7OnClick() {
     addChar(TextField.caption, key_7.caption[0]);
     return;
}

void key_8OnClick() {
     addChar(TextField.caption, key_8.caption[0]);
     return;
}

void key_9OnClick() {
     addChar(TextField.caption, key_9.caption[0]);
     return;
}

void key_0OnClick() {
     addChar(TextField.caption, key_0.caption[0]);
     return;
}

void key_aOnClick() {
     addChar(TextField.caption, key_a.caption[0]);
     return;
}

void key_zOnClick() {
     addChar(TextField.caption, key_z.caption[0]);
     return;
}

void key_eOnClick() {
     addChar(TextField.caption, key_e.caption[0]);
     return;
}

void key_rOnClick() {
     addChar(TextField.caption, key_r.caption[0]);
     return;
}

void key_tOnClick() {
     addChar(TextField.caption, key_t.caption[0]);
     return;
}

void key_yOnClick() {
     addChar(TextField.caption, key_y.caption[0]);
     return;
}

void key_uOnClick() {
     addChar(TextField.caption, key_u.caption[0]);
     return;
}

void key_iOnClick() {
     addChar(TextField.caption, key_i.caption[0]);
     return;
}

void key_oOnClick() {
     addChar(TextField.caption, key_o.caption[0]);
     return;
}

void key_pOnClick() {
     addChar(TextField.caption, key_p.caption[0]);
     return;
}

void key_qOnClick() {
     addChar(TextField.caption, key_q.caption[0]);
     return;
}

void key_xOnClick() {
     addChar(TextField.caption, key_x.caption[0]);
     return;
}

void key_cOnClick() {
     addChar(TextField.caption, key_c.caption[0]);
     return;
}

void key_sOnClick() {
     addChar(TextField.caption, key_s.caption[0]);
     return;
}

void key_dOnClick() {
     addChar(TextField.caption, key_d.caption[0]);
     return;
}

void key_fOnClick() {
     addChar(TextField.caption, key_f.caption[0]);
     return;
}

void key_gOnClick() {
     addChar(TextField.caption, key_g.caption[0]);
     return;
}

void key_hOnClick() {
     addChar(TextField.caption, key_h.caption[0]);
     return;
}

void key_jOnClick() {
     addChar(TextField.caption, key_j.caption[0]);
     return;
}

void key_kOnClick() {
     addChar(TextField.caption, key_k.caption[0]);
     return;
}

void key_lOnClick() {
     addChar(TextField.caption, key_l.caption[0]);
     return;
}

void key_mOnClick() {
     addChar(TextField.caption, key_m.caption[0]);
     return;
}

void key_shiftOnClick() { 
    int j = 0;
    TButton_Round * const code keys[26] = {
                   &key_a,&key_z,&key_e,&key_r,&key_t,&key_y,&key_u,&key_i,&key_o,&key_p,
                   &key_q,&key_s,&key_d,&key_f,&key_g,&key_h,&key_j,&key_k,&key_l,&key_m,
                   &key_w,&key_x,&key_c,&key_v,&key_b,&key_n };

    if (toogle == 0) {
         // toUpperCase 
         for (j=0; j<26; j++) toUpperCase(keys[j]->caption);
         key_shift.Gradient_Start_Color    = 0xC618;
         key_shift.Gradient_End_Color      = 0xFFFF;
         toogle = 1;
    }
    else {
         // toLowerCase
         for (j=0; j<26; j++) toLowerCase(keys[j]->caption);
         key_shift.Gradient_Start_Color    = 0xFFFF;
         key_shift.Gradient_End_Color      = 0xC618;
         toogle = 0;
    }
    DrawScreen(&PinCode); 
}

void key_wOnClick() {
     addChar(TextField.caption, key_w.caption[0]);
     return;
}

void key_vOnClick() {
     addChar(TextField.caption, key_v.caption[0]);
     return;
}

void key_bOnClick() {
     addChar(TextField.caption, key_b.caption[0]);
     return;
}

void key_nOnClick() {
     addChar(TextField.caption, key_n.caption[0]);
     return;
}

void key_backOnClick() {
     delChar(TextField.caption);
     return;
}

void ButtonSearchOnClick() {
     DrawInqScreen();
}

void Button3OnClick() {
     DrawInqScreen();
}

void OkButtonOnClick() {
     DrawScreen(&HomeScreen);
}

void Button6OnClick() {
     DrawPinScreen();
}
