/*
 * Project name:
     test_bt.vtft
 * Generated by:
     Visual TFT
 * Date of creation
     13/01/2013
 * Time of creation
     11:46:31
 * Test configuration:
     MCU:             P32MX460F512L
     Dev.Board:       MikroMMB_for_PIC32_hw_rev_1.10
                      http://www.mikroe.com/eng/products/view/595/mikrommb-for-pic32-board/
     Oscillator:      80000000 Hz
     SW:              mikroC PRO for PIC32
                      http://www.pic32compilers.com/
 */

#include "test_bt_objects.h"

const NBR_DIR = 3;
const NBR_FIL = 10;

char lstDir[NBR_DIR][13];

char top;

int fileIndex;
int minFileIndex;
int maxFileIndex;

unsigned long i, file_size;
const BUFFER_SIZE = 512;
char  BufferLarge[BUFFER_SIZE];
char  volume;

short fhandle;

void Tmr2_isr() iv IVT_TIMER_2 ilevel 7 ics ICS_SRS {
     Check_TP();
     T2IF_bit = 0;
}


void InitTimer2() {
  TMR2 = 0;                 // reset timer value to zero
  PR2 = 65535;              // Load period register

  T2IP0_bit = 1;            // set interrupt
  T2IP1_bit = 1;            // priority
  T2IP2_bit = 1;            // to 7

  TCKPS0_bit = 1;           // Set Timer Input Clock
  TCKPS1_bit = 1;           // Prescale value to 1:256

  EnableInterrupts();       // Enable all interrupts

  T2IE_bit = 1;             // Enable Timer1 Interrupt
  ON__T2CON_bit = 1;        // Enable Timer1
}

void main() {
  
  trisd.f11 = 0;
  
  // Reset Parani ESD 110
  latd.f11 = 0;
  Delay_ms(1500);
  latd.f11 = 1;
  
  CHECON = 30;
  AD1PCFG = 0xFFFF;

  Start_TP();
  
  MM_Init();
  
  InitTimer2();

  UART1_Init(9600);               // Initialize UART module at 9600 bps
  Delay_ms(100);                  // Wait for UART module to stabilize

  while(1);
}
