typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct  Button {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          *Caption;
  TTextAlign    TextAlign;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TButton;

typedef const struct  CButton {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  const char          *Caption;
  TTextAlign    TextAlign;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCButton;

typedef struct  Button_Round {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          *Caption;
  TTextAlign    TextAlign;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          Corner_Radius;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TButton_Round;

typedef struct  Label {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

typedef const struct  CLabel {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  const char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCLabel;

typedef struct  Box {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox;

typedef const struct  CBox {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCBox;

typedef struct  Line {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  First_Point_X;
  unsigned int  First_Point_Y;
  unsigned int  Second_Point_X;
  unsigned int  Second_Point_Y;
  char          Pen_Width;
  char          Visible;
  unsigned int  Color;
} TLine;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned int         ObjectsCount;
  unsigned int           ButtonsCount;
  TButton                * const code *Buttons;
  unsigned int           CButtonsCount;
  TCButton                * const code *CButtons;
  unsigned int           Buttons_RoundCount;
  TButton_Round          * const code *Buttons_Round;
  unsigned int           LabelsCount;
  TLabel                 * const code *Labels;
  unsigned int           CLabelsCount;
  TCLabel                 * const code *CLabels;
  unsigned int           BoxesCount;
  TBox                   * const code *Boxes;
  unsigned int           CBoxesCount;
  TCBox                   * const code *CBoxes;
  unsigned int           LinesCount;
  TLine                 * const code *Lines;
};

extern   TScreen                HomeScreen;
extern   TCLabel          Title1;
extern   TLine                  Line1;
extern   TButton               Info_Button;
extern   TButton               ButtonSearch;
extern   TButton               Button6;
extern   TButton                * const code Screen1_Buttons[3];
extern   TCLabel                 * const code Screen1_CLabels[1];
extern   TLine                  * const code Screen1_Lines[1];


extern   TScreen                InfoScreen;
extern   TCLabel          Title2;
extern   TLine                  Line2;
extern   TLabel                 BtAdresseLbl;
extern   TLabel                 DevNameLbl;
extern   TLabel                 ModeLbl;
extern   TLabel                 StatusLbl;
extern   TLabel                 AuthLbl;
extern   TLabel                 EncrLbl;
extern   TLabel                 FlowLbl;
extern   TCLabel          Label1;
extern   TCLabel          Label2;
extern   TCLabel          Label3;
extern   TCLabel          Label4;
extern   TCLabel          Label5;
extern   TCLabel          Label6;
extern   TCLabel          Label7;
extern   TButton               BackButton;
extern   TButton                * const code Screen2_Buttons[1];
extern   TLabel                 * const code Screen2_Labels[7];
extern   TCLabel                 * const code Screen2_CLabels[8];
extern   TLine                  * const code Screen2_Lines[1];


extern   TScreen                InqScreen;
extern   TCBox                Box1;
extern   TLabel                 InqTitle;
extern   TLine                  Line3;
extern   TCButton                Button2;
extern   TCButton                Button3;
extern   TButton               dev1;
extern   TButton               dev2;
extern   TButton               dev3;
extern   TButton               dev4;
extern   TButton               dev5;
extern   TButton               dev6;
extern   TButton               dev7;
extern   TButton               dev8;
extern   TButton               dev9;
extern   TButton               dev10;
extern   TButton               dev11;
extern   TButton               dev12;
extern   TButton               dev13;
extern   TButton               dev14;
extern   TButton               dev15;
extern   TButton                * const code Screen3_Buttons[15];
extern   TCButton                * const code Screen3_CButtons[2];
extern   TLabel                 * const code Screen3_Labels[1];
extern   TCBox                   * const code Screen3_CBoxes[1];
extern   TLine                  * const code Screen3_Lines[1];


extern   TScreen                ConErrorScreen;
extern   TLabel                 Label8;
extern   TButton_Round          OkButton;
extern   TLabel                 Label10;
extern   TButton_Round          * const code Screen4_Buttons_Round[1];
extern   TLabel                 * const code Screen4_Labels[2];


extern   TScreen                ConSuccessScreen;
extern   TLabel                 SuccessLabel;
extern   TLabel                 * const code Screen5_Labels[1];


extern   TScreen                DiscoScreen;
extern   TCLabel          Label9;
extern   TButton_Round          ButtonRound1;
extern   TButton_Round          DiscoButton;
extern   TButton_Round          * const code Screen6_Buttons_Round[2];
extern   TCLabel                 * const code Screen6_CLabels[1];


extern   TScreen                PinCode;
extern   TLine                  Line4;
extern   TCLabel          Label11;
extern   TBox                   cache_pin_str;
extern   TLabel                 TextField;
extern   TButton_Round          key_a;
extern   TButton_Round          key_z;
extern   TButton_Round          key_e;
extern   TButton_Round          key_r;
extern   TButton_Round          key_t;
extern   TButton_Round          key_y;
extern   TButton_Round          key_u;
extern   TButton_Round          key_i;
extern   TButton_Round          key_o;
extern   TButton_Round          key_p;
extern   TButton_Round          key_q;
extern   TButton_Round          key_s;
extern   TButton_Round          key_d;
extern   TButton_Round          key_f;
extern   TButton_Round          key_g;
extern   TButton_Round          key_h;
extern   TButton_Round          key_j;
extern   TButton_Round          key_k;
extern   TButton_Round          key_l;
extern   TButton_Round          key_m;
extern   TButton_Round          key_1;
extern   TButton_Round          key_2;
extern   TButton_Round          key_3;
extern   TButton_Round          key_4;
extern   TButton_Round          key_5;
extern   TButton_Round          key_6;
extern   TButton_Round          key_7;
extern   TButton_Round          key_8;
extern   TButton_Round          key_9;
extern   TButton_Round          key_0;
extern   TButton_Round          key_w;
extern   TButton_Round          key_x;
extern   TButton_Round          key_c;
extern   TButton_Round          key_v;
extern   TButton_Round          key_b;
extern   TButton_Round          key_n;
extern   TButton_Round          key_shift;
extern   TButton_Round          key_back;
extern   TCButton                Button4;
extern   TCButton                Button5;
extern   TCButton                * const code Screen7_CButtons[2];
extern   TButton_Round          * const code Screen7_Buttons_Round[38];
extern   TLabel                 * const code Screen7_Labels[1];
extern   TCLabel                 * const code Screen7_CLabels[1];
extern   TBox                   * const code Screen7_Boxes[1];
extern   TLine                  * const code Screen7_Lines[1];



/////////////////////////
// Events Code Declarations
void BackButtonOnClick();
void Button1OnClick();
void Button3OnClick();
void Button6OnClick();
void ButtonMoinsOnClick();
void ButtonPlusOnClick();
void ButtonSearchOnClick();
void dev10OnClick();
void dev11OnClick();
void dev12OnClick();
void dev13OnClick();
void dev14OnClick();
void dev15OnClick();
void dev1OnClick();
void dev2OnClick();
void dev3OnClick();
void dev4OnClick();
void dev5OnClick();
void dev6OnClick();
void dev7OnClick();
void dev8OnClick();
void dev9OnClick();
void DiscoButtonOnClick();
void Info_ButtonOnClick();
void key_0OnClick();
void key_1OnClick();
void key_2OnClick();
void key_3OnClick();
void key_4OnClick();
void key_5OnClick();
void key_6OnClick();
void key_7OnClick();
void key_8OnClick();
void key_9OnClick();
void key_aOnClick();
void key_backOnClick();
void key_bOnClick();
void key_cOnClick();
void key_dOnClick();
void key_eOnClick();
void key_fOnClick();
void key_gOnClick();
void key_hOnClick();
void key_iOnClick();
void key_jOnClick();
void key_kOnClick();
void key_lOnClick();
void key_mOnClick();
void key_nOnClick();
void key_oOnClick();
void key_pOnClick();
void key_qOnClick();
void key_rOnClick();
void key_shiftOnClick();
void key_sOnClick();
void key_tOnClick();
void key_uOnClick();
void key_vOnClick();
void key_wOnClick();
void key_xOnClick();
void key_yOnClick();
void key_zOnClick();
void NextButtonOnClick();
void OkButtonOnClick();
void PlayerButtonOnClick();
void PlayPauseButtonOnClick();
void PreviousButtonOnClick();
void StopButtonOnClick();
void Test_ELM327OnClick();
void TestGaugeButtonOnClick();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern const char Title1_Caption[];
extern char Line1_Caption[];
extern char Info_Button_Caption[];
extern char ButtonSearch_Caption[];
extern char Button6_Caption[];
extern const char Title2_Caption[];
extern char Line2_Caption[];
extern char BtAdresseLbl_Caption[];
extern char DevNameLbl_Caption[];
extern char ModeLbl_Caption[];
extern char StatusLbl_Caption[];
extern char AuthLbl_Caption[];
extern char EncrLbl_Caption[];
extern char FlowLbl_Caption[];
extern const char Label1_Caption[];
extern const char Label2_Caption[];
extern const char Label3_Caption[];
extern const char Label4_Caption[];
extern const char Label5_Caption[];
extern const char Label6_Caption[];
extern const char Label7_Caption[];
extern char BackButton_Caption[];
extern const char Box1_Caption[];
extern char InqTitle_Caption[];
extern char Line3_Caption[];
extern const char Button2_Caption[];
extern const char Button3_Caption[];
extern char dev1_Caption[];
extern char dev2_Caption[];
extern char dev3_Caption[];
extern char dev4_Caption[];
extern char dev5_Caption[];
extern char dev6_Caption[];
extern char dev7_Caption[];
extern char dev8_Caption[];
extern char dev9_Caption[];
extern char dev10_Caption[];
extern char dev11_Caption[];
extern char dev12_Caption[];
extern char dev13_Caption[];
extern char dev14_Caption[];
extern char dev15_Caption[];
extern char Label8_Caption[];
extern char OkButton_Caption[];
extern char Label10_Caption[];
extern char SuccessLabel_Caption[];
extern const char Label9_Caption[];
extern char ButtonRound1_Caption[];
extern char DiscoButton_Caption[];
extern char Line4_Caption[];
extern const char Label11_Caption[];
extern char cache_pin_str_Caption[];
extern char TextField_Caption[];
extern char key_a_Caption[];
extern char key_z_Caption[];
extern char key_e_Caption[];
extern char key_r_Caption[];
extern char key_t_Caption[];
extern char key_y_Caption[];
extern char key_u_Caption[];
extern char key_i_Caption[];
extern char key_o_Caption[];
extern char key_p_Caption[];
extern char key_q_Caption[];
extern char key_s_Caption[];
extern char key_d_Caption[];
extern char key_f_Caption[];
extern char key_g_Caption[];
extern char key_h_Caption[];
extern char key_j_Caption[];
extern char key_k_Caption[];
extern char key_l_Caption[];
extern char key_m_Caption[];
extern char key_1_Caption[];
extern char key_2_Caption[];
extern char key_3_Caption[];
extern char key_4_Caption[];
extern char key_5_Caption[];
extern char key_6_Caption[];
extern char key_7_Caption[];
extern char key_8_Caption[];
extern char key_9_Caption[];
extern char key_0_Caption[];
extern char key_w_Caption[];
extern char key_x_Caption[];
extern char key_c_Caption[];
extern char key_v_Caption[];
extern char key_b_Caption[];
extern char key_n_Caption[];
extern char key_shift_Caption[];
extern char key_back_Caption[];
extern const char Button4_Caption[];
extern const char Button5_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawCButton(TCButton *aCButton);
void DrawRoundButton(TButton_Round *Around_button);
void DrawLabel(TLabel *ALabel);
void DrawCLabel(TCLabel *AClabel);
void DrawBox(TBox *ABox);
void DrawCBox(TCBox *ACbox);
void DrawLine(TLine *Aline);
void Check_TP();
void Start_TP();
